package com.sos.dailyschedule.dialog.classes;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

import com.sos.dashboard.globals.DashBoardConstants;
import com.sos.dialog.classes.SOSTable;
import com.sos.dialog.components.SOSTableColumn;
import com.sos.jid.dialog.classes.SOSMenuLimitItem;
import com.sos.jid.dialog.classes.SosTabLogItem;
import com.sos.localization.Messages;

/**
* \class SosHistoryTable 
* 
* \brief SosHistoryTable - 
* 
* \details
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 31.01.2012
* \see reference
*
* Created on 31.01.2012 09:59:28
 */
public class SosHistoryTable extends SOSSchedulerJIDHistoryTable {
	@SuppressWarnings("unused")
	private final String	conClassName	= "SosHistoryTable";
	private SOSTableColumn	c1;
	private SOSTableColumn	c2;
	private SOSTableColumn	c3;
	private SOSTableColumn	c4;

	public SosHistoryTable(Composite composite, int style, Messages messages_) {
		super(composite, style);
		createTable();
		messages = messages_;
		createMenueTableHistoryDetail();
	}

	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	
    @Override
    public void createTable() {
        this.setSortDirection(SWT.UP);
        this.setLinesVisible(true);
        this.setHeaderVisible(true);
        Messages messages = new Messages(DashBoardConstants.conPropertiesFileName);
        c1 = new SOSTableColumn(this, SWT.NONE, messages.getLabel(DashBoardConstants.conSOSDashB_START), 90, SOSTableColumn.ColumnType.DATE);
        c2 = new SOSTableColumn(this, SWT.NONE, messages.getLabel(DashBoardConstants.conSOSDashB_END), 90, SOSTableColumn.ColumnType.DATE);
        c3 = new SOSTableColumn(this, SWT.NONE, messages.getLabel(DashBoardConstants.conSOSDashB_DURATION), 90);
        c4 = new SOSTableColumn(this, SWT.NONE, messages.getLabel(DashBoardConstants.conSOSDashB_EXIT), 90);
        setMoveableColums(true);
        
    }
    
    private void createMenueTableHistoryDetail() {
        Menu contentMenuHistory = new Menu(this);
        this.setMenu(contentMenuHistory);
        // =============================================================================================
        MenuItem showLogHistory = new MenuItem(contentMenuHistory, SWT.PUSH);
        showLogHistory.setText(messages.getLabel(DashBoardConstants.conSOSDashB_show_log_in_new_tab));
        showLogHistory.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            @Override
            public void widgetSelected(final org.eclipse.swt.events.SelectionEvent e) {
                SosTabLogItem tbtmLog = new SosTabLogItem(conTabLOG, logTabFolder, messages);
                logTabFolder.setSelection(tbtmLog);
                showLog();
            }

            @Override
            public void widgetDefaultSelected(final org.eclipse.swt.events.SelectionEvent e) {
            }
        });
       
        
        MenuItem excel = new MenuItem(contentMenuHistory, SWT.PUSH);
        excel.setText(messages.getLabel(DashBoardConstants.conSOSDashB_Export_To_Excel));
        excel.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
              public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                  createExcelFile();
              }

              public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
              }
          });

        // =============================================================================================

    }
        
    
}
