package com.sos.jade.db;

 
import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.hibernate.Query;


import com.sos.hibernate.layer.SOSHibernateDBLayer;
import com.sos.jade.JadeHistoryFilter;





/**
* \class JadeTransferSelector 
* 
* \brief JadeTransferSelector - 
* 
* \details
*
* \section JadeTransferSelector.java_intro_sec Introduction
*
* \section JadeTransferSelector.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 13.09.2011
* \see reference
*
* Created on 13.09.2011 14:40:18
 */

public class JadeTransferDBLayer extends SOSHibernateDBLayer {

	@SuppressWarnings("unused")
	private final String	conClassName	= "JadeTransferDBLayer";
	protected Date createdFrom;
	protected Date createdTo;
	
	protected String whereProfileName=null;
	protected String whereStatus=null;
	protected Date whereStartTime=null;
	protected Date whereEndTime=null;
	protected String whereStartTimeIso;
	protected String whereEndTimeIso;
 	protected String dateFormat;	
 	private JadeHistoryFilter filter;
 	private   int age;
	

	public JadeTransferDBLayer(File configurationFile)  {
		super();
		this.setConfigurationFile(configurationFile);
		this.dateFormat = "dd.MM.yyyy hh:mm";
		//
	} 
	 
	public JadeHistoryFilter getFilter() {
		return filter;
	}
	
	public void setFilter(JadeHistoryFilter filter_) {
		filter = filter_;
	}
	
	protected String getWhereFromTo() {
		return " created >= :createdFrom and created <= :createdTo";	
	}
	
	 
	public void setAge(int age) throws ParseException {
		
		Date now = new Date();
		GregorianCalendar calendar = new GregorianCalendar();
		calendar.setTime(now);
		calendar.add(GregorianCalendar.DAY_OF_MONTH, age*(-1));
		now = calendar.getTime();
	    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        String froms = formatter.format(now);
    	froms = froms + "T00:00:00";
		formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
		
		this.setCreatedTo(new Date());
		this.setCreatedFrom(formatter.parse(froms));	
		this.age = age;
	}

	public List <JadeTransferDBItem>  getTransfersFromTo() throws ParseException {
			beginTransaction();
			 
			Query query = session.createQuery("  from JadeTransferDBItem where " + getWhereFromTo());

			query.setTimestamp("createdFrom", createdFrom);
			query.setTimestamp("createdTo", createdTo);

			List  <JadeTransferDBItem>  resultset = query.list();
	 
			commit();
			return resultset;

		}
	
 
	 protected String getWhere() {
			String where = "";
			String and = "";
			if (whereProfileName != null && !whereProfileName.equals("")) {
				where += and + " profileName='" + whereProfileName + "'";
				and = " and ";
			}
			if (whereStatus != null && !whereStatus.equals("")) {
				where += and + " status=" + whereStatus ;
				and = " and ";
			}
			 
		 

			if (whereStartTime != null && !whereStartTime.equals("")) {
				where += and + " startTime>= :startTime";
				and = " and ";
			}

			if (whereEndTime != null &&  !whereEndTime.equals("")) {
				where += and + " endTime <= :endTime ";
				and = " and ";
			}
			if (where.trim().equals("")) {
			   
			}else {
				where = "where " + where;
			}
			return where;
	       
	   }
		
		public List <JadeTransferDBItem> getTransferList(int limit)  {
			beginTransaction();
			Query query=session.createQuery( "from JadeTransferDBItem " + getWhere()); 
					
			if (whereStartTime != null &&  !whereStartTime.equals("")) {
				query.setDate("startTime", whereStartTime);
			}
			if (whereEndTime != null &&  !whereEndTime.equals("")) {
				query.setDate("endTime", whereEndTime);
			}
		
		    query.setMaxResults(limit);
		    
			List <JadeTransferDBItem> transferList=query.list();
			commit();	
			return transferList;

		}

	 		
		public int deleteFromTo(String tableName) {
			initSession();
		 	String hql = "delete from " + tableName + " where " + getWhereFromTo();

			Query query = session.createQuery(hql);
			
			if (createdFrom != null && !createdFrom.equals("")) {
				query.setTimestamp("createdFrom", createdFrom);
			}
			if (createdTo != null && !createdTo.equals("")) {
				query.setTimestamp("createdTo", createdTo);
			}
		 
			int row = query.executeUpdate();

			return row;
		}		
		
		public int deleteFromTo() {
		 	int row = deleteFromTo("JadeTransferDBItem");
		 	return row;
		}
		
		public void setWhereProfileName(String whereProfileName) {
			this.whereProfileName= whereProfileName;
		}

		public void setWhereStatus(String whereStatus) {
			this.whereStatus = whereStatus;
		}

		 

		public void setWhereStartTime(Date whereStartTime) {
			this.whereStartTime = whereStartTime;
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd hh:mm");
		    whereStartTimeIso = formatter.format(whereStartTime);
		}

		public void setWhereEndTime(Date whereEndTime) {
			this.whereEndTime = whereEndTime;
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd hh:mm");
		    whereEndTimeIso = formatter.format(whereEndTime);
		}
		
		public void setWhereStartTime(String whereStartTime) throws ParseException {
			if (whereStartTime.equals("")) {
				this.whereStartTime = null;
			}else {
	 	        SimpleDateFormat formatter = new SimpleDateFormat("dd.MM.yyyy hh:mm");
		        Date d = formatter.parse(whereStartTime);
				setWhereStartTime(d);
			}
		}

		public void setWhereEndTime(String whereEndTime) throws ParseException {
			if (whereEndTime.equals("")) {
				this.whereEndTime = null;
			}else {
	 	        SimpleDateFormat formatter = new SimpleDateFormat("dd.MM.yyyy hh:mm");
	 	   	    Date d = formatter.parse(whereEndTime);
	 	   		setWhereEndTime(d);
			}
		}	
	
	public void setCreatedFrom(Date createdFrom) {
		this.createdFrom = createdFrom;
	}

	public void setCreatedTo(Date createdTo) {
		this.createdTo = createdTo;
	}
		 
	public void setDateFormat(String dateFormat) {
		this.dateFormat = dateFormat;
	}

	public void setCreatedFrom(String createdFrom) throws ParseException {
		SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
		this.createdFrom = formatter.parse(createdFrom);
	}

	public void setCreatedTo(String createdTo) throws ParseException {
		SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
		this.createdTo = formatter.parse(createdTo);
	} 	
	
	public void save (JadeTransferDBItem transferItem) {
		if (transferItem.getSession() == null) {
		   session = getSession();
		   transferItem.setSession(session);
		}

		transaction = transferItem.getSession().beginTransaction();
		transferItem.save();
	}
}
