// $Id: soserror.cxx 14124 2010-11-04 09:30:47Z jz $

// 1727
// 1735

#include "precomp.h"
#include <stdlib.h>
#include "soserror.h"

namespace sos {

Soserror_text soserror_texts[] = 
{
    { "BFA2RTF-1"                       , "Verzeichnis <root>/als/... kann nicht angelegt werden" },
    { "BFA2RTF-2"                       , "Satz in Q.Z291D.Z4 hat nicht die richtige Lnge" },
    { "BFA2RTF-3"                       , "Ungltiges Datum im Elementnamen in Q.FRAME.BB" },
    { "BFA2RTF-4"                       , "Elementname $1 in Q.FRAME.EB nicht ipnE" },
    { "BFA2RTF-5"                       , "Elementname $1 in Q.FRAME.BB nicht IipnBxxyyyjjmmttnn" },
    { "BFA2RTF-6"                       , "Bibliothekselement nicht erkannt" },
    { "BFA2RTF-7"                       , "Kennsatz \"FILENAME IS : \" fehlt" },
    { "BS2-LINK-00000004"               , "Das Objektmodul kann nicht geladen werden" },
    { "BS2-LINK-FFFFFFFF"               , "Parameterfehler beim LINK-SVC" },
    { "BS2-OPCOM-04"                    , "(Programmfehler?) Operandenfehler" },
    { "BS2-OPCOM-08"                    , "IPK-Name ist vergeben. IPK-Teilnahme ist nicht eroeffnet" },
    { "BS2-OPCOM-0C"                    , "Kein Systemspeicher zur Eroeffnung der IPK verfuegbar oder die systeminterne Groesse fuer Empfangswarteschlangen ist ueberschritten" },
    { "BS2-OPCOM-10"                    , "IPK-Teilnahme wurde von diesem Prozess bereits eroeffnet" },
    { "BS2-REVNT-04"                    , "(Programmfehler?) Operandenfehler" },
    { "BS2-REVNT-08"                    , "(Programmfehler?) IPK ist nicht eroeffnet worden" },
    { "BS2-REVNT-0C"                    , "Eingabepufferueberlauf. Der Satz (die Zeile) ist zu lang" },
    { "BS2-REVNT-10"                    , "keine Nachricht innerhalb der Wartezeit empfangen" },
    { "BS2-SEVNT-08"                    , "(Programmfehler?) IPK ist nicht eroeffnet worden" },
    { "BS2-SEVNT-0C"                    , "Systemspeicher fuer die Daten ist voll" },
    { "BS2-SEVNT-10"                    , "der Empfaenger ist nicht bekannt" },
    { "BS2-WROUT-04"                    , "Nicht behebbarer Fehler" },
    { "BS2-WROUT-08"                    , "Operandenfehler" },
    { "BS2-WROUT-0C"                    , "Ausgabe zu lang, abgeschnitten" },
    { "BS2-WROUT-10"                    , "An der Datenstation wurde \"BREAK\" whrend der Ausfhrung des Makroaufrufs gegeben" },
    { "BS2-WROUT-20"                    , "Ungltige Edit Option; wurde vom System korrigiert" },
    { "BS2-WRTRD-04"                    , "Nicht behebbarer Fehler" },
    { "BS2-WRTRD-08"                    , "Operandenfehler" },
    { "BS2-WRTRD-0C"                    , "Satz beim Einlesen abgeschnitten, weil der Puffer zu klein ist" },
    { "BS2-WRTRD-10"                    , "An der Datenstation wurde \"BREAK\" whrend der Ausfhrung des Makroaufrufs gegeben" },
    { "BS2-WRTRD-14"                    , "WRTRD wurde in einem Spapelauftrag (Batch) aufgerufen" },
    { "BS2-WRTRD-20"                    , "Ungltige Edit Option; wurde vom System korrigiert" },
    { "BS2-WRTRD-2C"                    , "Die Eingabe beginnt mit Steuerzeichen NL (bei EXTEND=YES). 3270: Eingabelnge verkrzt" },
    { "BTRIEVE-1"                       , "Invalid operation" },
    { "BTRIEVE-10"                      , "Modifiable key value error" },
    { "BTRIEVE-1001"                    , "Lock Parameter out of range" },
    { "BTRIEVE-1002"                    , "Memory Allocation Error" },
    { "BTRIEVE-1003"                    , "Memory Specification Too Small" },
    { "BTRIEVE-1004"                    , "Page Size Parameter out of range" },
    { "BTRIEVE-1005"                    , "Invalid pre-image drive parameter" },
    { "BTRIEVE-1006"                    , "Pre-Image Buffer Size out of range" },
    { "BTRIEVE-1007"                    , "Maximum Files Parameter Invalid (option /f:)" },
    { "BTRIEVE-1008"                    , "Invalid Initialization Parameter" },
    { "BTRIEVE-1009"                    , "Error Writing Transaction Control File (option /t:)" },
    { "BTRIEVE-1010"                    , "Unable to access Btrieve file for transaction recovery" },
    { "BTRIEVE-1011"                    , "Compression Buffer Out Of Range" },
    { "BTRIEVE-1012"                    , "Invalid value for /N: option (maximum number of open files)" },
    { "BTRIEVE-1013"                    , "Maximum number of tasks reached" },
    { "BTRIEVE-1014"                    , "Files Left Open or Transaction Active" },
    { "BTRIEVE-1016"                    , "Already initialized" },
    { "BTRIEVE-11"                      , "Invalid file name" },
    { "BTRIEVE-12"                      , "File not found" },
    { "BTRIEVE-13"                      , "Extended file error" },
    { "BTRIEVE-14"                      , "Pre-image open error" },
    { "BTRIEVE-15"                      , "Pre-image i/o error" },
    { "BTRIEVE-16"                      , "Expansion error" },
    { "BTRIEVE-17"                      , "Close error" },
    { "BTRIEVE-18"                      , "Disk full" },
    { "BTRIEVE-19"                      , "Unrecoverable error" },
    { "BTRIEVE-2"                       , "I/O Error" },
    { "BTRIEVE-20"                      , "Record manager inactive" },
    { "BTRIEVE-2001"                    , "Insufficient memory" },
    { "BTRIEVE-2002"                    , "Parameter invalid or out of range" },
    { "BTRIEVE-2003"                    , "Cannot access files on local disk (server version of Btrieve)" },
    { "BTRIEVE-2004"                    , "SPX is not installed (Novell-login fehlt)" },
    { "BTRIEVE-2005"                    , "Wrong version of SPX installed" },
    { "BTRIEVE-2006"                    , "No available SPX connection" },
    { "BTRIEVE-2007"                    , "Maximum number of applications active (max 10)" },
    { "BTRIEVE-2008"                    , "Insufficient memory (WBTRCALL)" },
    { "BTRIEVE-2009"                    , "Files are open (WARNING)" },
    { "BTRIEVE-21"                      , "Key buffer too short" },
    { "BTRIEVE-2101"                    , "Requester's /d: parameter is too small" },
    { "BTRIEVE-2102"                    , "Requester's /r: parameter is too small" },
    { "BTRIEVE-2103"                    , "Bserver not active or session closed (Netzwerk-Verwalter fragen)" },
    { "BTRIEVE-2106"                    , "Bserver's message buffer too small (Netzwerk-Verwalter fragen)" },
    { "BTRIEVE-2110"                    , "Requester could not open a socket" },
    { "BTRIEVE-22"                      , "Data buffer length" },
    { "BTRIEVE-23"                      , "Position block length" },
    { "BTRIEVE-24"                      , "Page size error (option /p:)" },
    { "BTRIEVE-25"                      , "Create i/o error" },
    { "BTRIEVE-26"                      , "Number of keys" },
    { "BTRIEVE-27"                      , "Invalid key position" },
    { "BTRIEVE-28"                      , "Invalid record length" },
    { "BTRIEVE-29"                      , "Invalid key length" },
    { "BTRIEVE-3"                       , "File not open" },
    { "BTRIEVE-30"                      , "Not a Btrieve file" },
    { "BTRIEVE-31"                      , "File already extended" },
    { "BTRIEVE-32"                      , "Extend i/o error" },
    { "BTRIEVE-34"                      , "Invalid extension name" },
    { "BTRIEVE-35"                      , "Directory error" },
    { "BTRIEVE-36"                      , "Transaction error" },
    { "BTRIEVE-37"                      , "Transaction is active" },
    { "BTRIEVE-38"                      , "Transaction control file i/o error" },
    { "BTRIEVE-39"                      , "End/abort transaction error" },
    { "BTRIEVE-4"                       , "Key value not found" },
    { "BTRIEVE-40"                      , "Transaction max files" },
    { "BTRIEVE-41"                      , "Operation not allowed" },
    { "BTRIEVE-42"                      , "Incomplete accellerated access" },
    { "BTRIEVE-43"                      , "Invalid record address" },
    { "BTRIEVE-44"                      , "Null key path" },
    { "BTRIEVE-45"                      , "Inconsistent key flags" },
    { "BTRIEVE-46"                      , "Access to file denied" },
    { "BTRIEVE-47"                      , "Maximum open files (option /f:)" },
    { "BTRIEVE-48"                      , "Invalid alternate sequence definition" },
    { "BTRIEVE-49"                      , "Key type error" },
    { "BTRIEVE-5"                       , "Duplicate key value" },
    { "BTRIEVE-50"                      , "Owner already set" },
    { "BTRIEVE-51"                      , "Invalid owner" },
    { "BTRIEVE-52"                      , "Error writing cache" },
    { "BTRIEVE-53"                      , "Invalid interface" },
    { "BTRIEVE-54"                      , "Variable page error" },
    { "BTRIEVE-55"                      , "Autoincrement error" },
    { "BTRIEVE-56"                      , "Incomplete index" },
    { "BTRIEVE-57"                      , "Expanded memory error" },
    { "BTRIEVE-58"                      , "Compression buffer too short (option /u:) (Datensatz ist zu lang)" },
    { "BTRIEVE-59"                      , "File already exists" },
    { "BTRIEVE-6"                       , "Invalid key number" },
    { "BTRIEVE-7"                       , "Different key number" },
    { "BTRIEVE-8"                       , "Invalid positioning" },
    { "BTRIEVE-80"                      , "Conflict" },
    { "BTRIEVE-81"                      , "Lock error" },
    { "BTRIEVE-82"                      , "Lost position" },
    { "BTRIEVE-83"                      , "Read outside transaction" },
    { "BTRIEVE-84"                      , "Record in use" },
    { "BTRIEVE-85"                      , "File in use" },
    { "BTRIEVE-86"                      , "File table full" },
    { "BTRIEVE-87"                      , "Handle table full" },
    { "BTRIEVE-88"                      , "Incompatible open mode" },
    { "BTRIEVE-9"                       , "End of file" },
    { "BTRIEVE-93"                      , "Incompatible lock type" },
    { "BTRIEVE-94"                      , "Permission error" },
    { "D0"                              , "Fehler beim Bearbeiten der Datei" },
    { "D001"                            , "Dateityp ist nicht definiert" },
    { "D002"                            , "Widerspruechliche Parameter" },
    { "D003"                            , "Unzulaessiger Parameter in der Parameterliste" },
    { "D004"                            , "Unzulaessiges Attribut beim Dateinamen oder Dateiname ist zu lang" },
    { "D005"                            , "Der Dateiname fehlt" },
    { "D006"                            , "Der Dateiname ist zu lang" },
    { "D007"                            , "Der Dateiname enthaelt nicht erlaubte Zeichen oder Zeichenkombinationen" },
    { "D008"                            , "Einrichten einer Bibliothek: Dateityp fehlt" },
    { "D009"                            , "Der Bibliotheksname fehlt" },
    { "D010"                            , "(key) auf die Datei kann nicht mit Schluesseln zugegriffen werden" },
    { "D011"                            , "Dateityp ist nicht installiert oder das Modul fehlt" },
    { "D012"                            , "Auf die Datei kann nicht mit einer Satznummer zugegriffen werden" },
    { "D013"                            , "Attribut ignkey nur bei kp=0 moeglich. \"getkey\" verwenden!" },
    { "D016"                            , "(f,rl) geforderte und tatsaechliche Satzlaenge sind verschieden" },
    { "D017"                            , "(kp) geforderte u. tatsaechl. Schluesselposition sind verschieden" },
    { "D018"                            , "(kl) geforderte und tatsaechl. Schluessellaenge sind verschieden" },
    { "D020"                            , "Der LINK-Name ist schon vergeben" },
    { "D021"                            , "Fuer den Dateityp ist keine OPEN-Routine definiert" },
    { "D022"                            , "Fuer den Dateityp ist keine CREATE-Routine definiert" },
    { "D023"                            , "Dieser Dateityp kennt keine Bibliotheken" },
    { "D024"                            , "Dieser Dateityp kennt keine Bibliotheken" },
    { "D025"                            , "Dieser Dateityp kennt kein Dateiverzeichnis (Directory)" },
    { "D026"                            , "Dateien dieses Typs koennen nicht gelesen werden" },
    { "D027"                            , "Dateien dieses Typs koennen nicht beschrieben werden" },
    { "D028"                            , "Eine Datei dieses Typs kann nicht mit \"append\" fortgeschrieben werden" },
    { "D030"                            , "Die Bibliothek ist nicht angegeben" },
    { "D031"                            , "Der open modus muss hier angegeben werden" },
    { "D032"                            , "Attribut \"nuc\" (File Server) beim Member-, nicht aber beim Bibliotheksnamen" },
    { "D039"                            , "Der Empfaenger existiert nicht" },
    { "D040"                            , "Die Datei existiert nicht (ist nicht eingerichtet)" },
    { "D041"                            , "Die Datei existiert logisch nicht" },
    { "D042"                            , "Die Datei ist gesperrt (nur lesbar oder schon zum Lesen geoeffnet)" },
    { "D043"                            , "Die Datei ist belegt" },
    { "D044"                            , "Die Datei ist von diesem Prozess bereits geoeffnet" },
    { "D045"                            , "Die Datei ist nur lesbar" },
    { "D046"                            , "Die Datei ist password-geschuetzt" },
    { "D047"                            , "Die Datei ist privat (nicht share)" },
    { "D048"                            , "Die Datei laesst sich mit diesem open modus nicht oeffnen" },
    { "D049"                            , "Der open modus ist fuer die Datei nicht erlaubt" },
    { "D050"                            , "Die Datei ist von anderer (unbekannter) Art oder fehlerhaft" },
    { "D051"                            , "Die Datei existiert bereits" },
    { "D052"                            , "Die Datei liegt in einem anderen Benutzer-Bereich" },
    { "D059"                            , "Die Datei ist nicht in Ordnung" },
    { "D060"                            , "Die Bibliothek existiert nicht (ist nicht eingerichtet)" },
    { "D061"                            , "Die Bibliothek existiert logisch nicht" },
    { "D062"                            , "Die Bibliothek ist gesperrt (nur lesbar oder schon geoeffnet)" },
    { "D063"                            , "Die Bibliothek ist belegt" },
    { "D064"                            , "Die Bibliothek ist von diesem Prozess bereits geoeffnet" },
    { "D065"                            , "Die Bibliothek ist nur lesbar" },
    { "D066"                            , "Die Bibliothek ist password-geschuetzt" },
    { "D067"                            , "Die Bibliothek ist privat (nicht share)" },
    { "D068"                            , "Die Bibliothek laesst sich mit diesem open modus nicht oeffnen" },
    { "D069"                            , "Der open modus ist fuer die Bibliothek nicht erlaubt" },
    { "D070"                            , "Die Bibliothek ist von anderer (unbekannter) Art" },
    { "D071"                            , "Die Bibliothek existiert bereits" },
    { "D072"                            , "Die Bibliothek liegt in einem anderen Benutzer-Bereich" },
    { "D079"                            , "Die Bibliothek ist nicht in Ordnung" },
    { "D080"                            , "Es ist nicht genuegend Platz fuer die Datei da" },
    { "D081"                            , "Der Datentraeger ist nicht zugreifbar (nicht eingehaengt)" },
    { "D097"                            , "Es ist (vermutlich) ein Betriebssystem-Fehler aufgetreten" },
    { "D098"                            , "Es ist (vermutlich) ein Programmfehler aufgetreten" },
    { "D1"                              , "Fehler beim Bearbeiten der Datei" },
    { "D101"                            , "Dateityp ist nicht definiert" },
    { "D102"                            , "Widerspruechliche Parameter" },
    { "D103"                            , "Unzulaessiger Parameter in der Parameterliste" },
    { "D104"                            , "Unzulaessiges Attribut beim Dateinamen oder Dateiname ist zu lang" },
    { "D105"                            , "Der Dateiname fehlt" },
    { "D106"                            , "Der Dateiname ist zu lang" },
    { "D107"                            , "Der Dateiname enthaelt nicht erlaubte Zeichen oder Zeichenkombinationen" },
    { "D108"                            , "Einrichten einer Bibliothek: Dateityp fehlt" },
    { "D109"                            , "Der Bibliotheksname fehlt" },
    { "D110"                            , "(key) auf die Datei kann nicht mit Schluesseln zugegriffen werden" },
    { "D111"                            , "Dateityp ist nicht installiert oder das Modul fehlt" },
    { "D112"                            , "Auf die Datei kann nicht mit einer Satznummer zugegriffen werden" },
    { "D113"                            , "Attribut ignkey nur bei kp=0 moeglich. \"getkey\" verwenden!" },
    { "D116"                            , "(f,rl) geforderte und tatsaechliche Satzlaenge sind verschieden" },
    { "D117"                            , "(kp) geforderte u. tatsaechl. Schluesselposition sind verschieden" },
    { "D118"                            , "(kl) geforderte und tatsaechl. Schluessellaenge sind verschieden" },
    { "D120"                            , "Der LINK-Name ist schon vergeben" },
    { "D121"                            , "Fuer den Dateityp ist keine OPEN-Routine definiert" },
    { "D122"                            , "Fuer den Dateityp ist keine CREATE-Routine definiert" },
    { "D123"                            , "Dieser Dateityp kennt keine Bibliotheken" },
    { "D124"                            , "Dieser Dateityp kennt keine Bibliotheken" },
    { "D125"                            , "Dieser Dateityp kennt kein Dateiverzeichnis (Directory)" },
    { "D126"                            , "Dateien dieses Typs koennen nicht gelesen werden" },
    { "D127"                            , "Dateien dieses Typs koennen nicht beschrieben werden" },
    { "D128"                            , "Eine Datei dieses Typs kann nicht mit \"append\" fortgeschrieben werden" },
    { "D130"                            , "Die Bibliothek ist nicht angegeben" },
    { "D131"                            , "Der open modus muss hier angegeben werden" },
    { "D132"                            , "Attribut \"nuc\" (File Server) beim Member-, nicht aber beim Bibliotheksnamen" },
    { "D139"                            , "Der Empfaenger existiert nicht" },
    { "D140"                            , "Die Datei existiert nicht (ist nicht eingerichtet)" },
    { "D141"                            , "Die Datei existiert logisch nicht" },
    { "D142"                            , "Die Datei ist gesperrt (nur lesbar oder schon zum Lesen geoeffnet)" },
    { "D143"                            , "Die Datei ist belegt" },
    { "D144"                            , "Die Datei ist von diesem Prozess bereits geoeffnet" },
    { "D145"                            , "Die Datei ist nur lesbar" },
    { "D146"                            , "Die Datei ist password-geschuetzt" },
    { "D147"                            , "Die Datei ist privat (nicht share)" },
    { "D148"                            , "Die Datei laesst sich mit diesem open modus nicht oeffnen" },
    { "D149"                            , "Der open modus ist fuer die Datei nicht erlaubt" },
    { "D150"                            , "Die Datei ist von anderer (unbekannter) Art oder fehlerhaft" },
    { "D151"                            , "Die Datei existiert bereits" },
    { "D152"                            , "Die Datei liegt in einem anderen Benutzer-Bereich" },
    { "D159"                            , "Die Datei ist nicht in Ordnung" },
    { "D160"                            , "Die Bibliothek existiert nicht (ist nicht eingerichtet)" },
    { "D161"                            , "Die Bibliothek existiert logisch nicht" },
    { "D162"                            , "Die Bibliothek ist gesperrt (nur lesbar oder schon geoeffnet)" },
    { "D163"                            , "Die Bibliothek ist belegt" },
    { "D164"                            , "Die Bibliothek ist von diesem Prozess bereits geoeffnet" },
    { "D165"                            , "Die Bibliothek ist nur lesbar" },
    { "D166"                            , "Die Bibliothek ist password-geschuetzt" },
    { "D167"                            , "Die Bibliothek ist privat (nicht share)" },
    { "D168"                            , "Die Bibliothek laesst sich mit diesem open modus nicht oeffnen" },
    { "D169"                            , "Der open modus ist fuer die Bibliothek nicht erlaubt" },
    { "D170"                            , "Die Bibliothek ist von anderer (unbekannter) Art" },
    { "D171"                            , "Die Bibliothek existiert bereits" },
    { "D172"                            , "Die Bibliothek liegt in einem anderen Benutzer-Bereich" },
    { "D179"                            , "Die Bibliothek ist nicht in Ordnung" },
    { "D180"                            , "Es ist nicht genuegend Platz fuer die Datei da" },
    { "D181"                            , "Der Datentraeger ist nicht zugreifbar (nicht eingehaengt)" },
    { "D197"                            , "Es ist (vermutlich) ein Betriebssystem-Fehler aufgetreten" },
    { "D198"                            , "Es ist (vermutlich) ein Programmfehler aufgetreten" },
    { "D201"                            , "@CLOS: Programmfehler: fuer den Dateityp existiert keine CLOSE-Routine" },
    { "D202"                            , "@CLOS: Invalid File ID" },
    { "D301"                            , "@GET (Lesen) ist fuer diese Datei nicht erlaubt" },
    { "D302"                            , "@GET: Invalid File ID" },
    { "D303"                            , "@GET (Lesen): die Datei ist nur zum Schreiben geoeffnet" },
    { "D304"                            , "@GET key/rec#: die Datei kann nur sequentiell gelesen werden" },
    { "D310"                            , "@GET: Dateiende (EOF)" },
    { "D311"                            , "@GET: Einen Satz mit dem gesuchten Schluessel gibt es nicht" },
    { "D312"                            , "@GET: REC# (Zeilennummer) liegt nicht innerhalb der Datei" },
    { "D313"                            , "@GET: Alles Stze bis END= gelesen" },
    { "D320"                            , "@GET: Die zu lesende Zeile ist zu lang (Pufferueberlauf)" },
    { "D321"                            , "@GET: Die zu lesende Zeile ist zu lang (interner Pufferueberlauf)" },
    { "D330"                            , "@GET mit REC#= und KEY= gleichzeitig ist nicht zulaessig" },
    { "D340"                            , "@INQUIRE KEY: Dateityp liefert keinen Satzschluessel" },
    { "D380"                            , "@GET: Der Satz ist nicht innerhalb der Wartezeit eingetroffen" },
    { "D401"                            , "@PUT (Schreiben) ist fuer diese Datei nicht erlaubt" },
    { "D402"                            , "@PUT: Invalid File ID" },
    { "D403"                            , "@PUT (Schreiben): Die Datei ist nur zum Lesen geoeffnet" },
    { "D404"                            , "@PUT key/rec#: die Datei kann nur sequentiell beschrieben werden" },
    { "D410"                            , "@PUT: \"EOF\". Es kann kein Satz mehr geschrieben werden (Datei ist voll)" },
    { "D411"                            , "@INS: einen Satz mit dem Schluessel gibt es bereits" },
    { "D412"                            , "@PUT: REC# (Zeilennummer) liegt nicht innerhalb der Datei" },
    { "D420"                            , "@PUT: Zeile ist zu lang (Pufferueberlauf)" },
    { "D421"                            , "@PUT: Zeile ist zu lang (interner Pufferueberlauf)" },
    { "D422"                            , "@PUT: Satzlaenge stimmt nicht mit der Dateisatzlaenge ueberein" },
    { "D430"                            , "@PUT mit REC#= und KEY= gleichzeitig ist nicht zulaessig" },
    { "D431"                            , "@PUT KEY= auf Datei ohne externen Schluessel" },
    { "D432"                            , "@PUT KEY auf Datei mit externen Schluessel" },
    { "D440"                            , "@PUT ist fuer diese Datei nicht erlaubt" },
    { "D441"                            , "@INS (einfuegen) ist fuer diese Datei nicht erlaubt" },
    { "D501"                            , "@SET ist fuer diese Datei nicht erlaubt" },
    { "D502"                            , "@SET: Invalid File ID" },
    { "D503"                            , "@SET: die Datei ist als sequential geoeffnet" },
    { "D504"                            , "@SET key/rec#: auf die Datei kann nur sequentiell zugegriffen werden" },
    { "D505"                            , "@SET: die Satznummer ist zu klein" },
    { "D506"                            , "@SET: die Satznummer ist zu gross" },
    { "D520"                            , "Die Komponente Rapid/Security ist nicht installiert" },
    { "D521"                            , "Zugriff ist nicht gestattet" },
    { "D601"                            , "@DEL: in dieser Datei duerfen keine Saetze entfernt werden" },
    { "D602"                            , "@DEL: Invalid File ID" },
    { "D603"                            , "@DEL: die Datei ist als sequential geoeffnet" },
    { "D604"                            , "@DEL: auf die Datei kann nur sequentiell zugegriffen werden" },
    { "D701"                            , "Der Dateityp kennt keine Transaktionen" },
    { "D810"                            , "rename: Dateien dieses Typs koennen nicht umbenannt werden" },
    { "D811"                            , "rename: Der Dateityp des neuen Namens ist verschieden von dem des alten Namens" },
    { "D812"                            , "rename: Die Bibliothek im neuen Namen ist nicht identisch zu der im alten" },
    { "D813"                            , "rename: Der neue Name ist nicht angegeben" },
    { "D820"                            , "erase: Dateien dieses Typs koennen nicht entfernt werden" },
    { "D850"                            , "Mehrere Dateien entsprechen diesem unvollstaendigen Dateinamen" },
    { "D900"                            , "Der Fileserver laeuft nicht" },
    { "D901"                            , "Der Fileserver ist nicht mehr aktiv" },
    { "D902"                            , "Im Fileserver kann der Dateityp NUC nicht verwendet werden" },
    { "D910"                            , "Ungueltige FSID fuer den Fileserver" },
    { "D911"                            , "Ungueltige oder veraltete FSID fuer den Fileserver (falscher Pruefcode)" },
    { "D915"                            , "Benutzer ist abgemeldet worden" },
    { "D916"                            , "Datei ist geschlossen worden" },
    { "DYNWIN-001"                      , "Die Vorgangsnummer '$1' hat nicht die richtige Lnge ($2)" },
    { "DYNWIN-002"                      , "Satz mit Vorgangsnummer '$1' nicht gefunden" },
    { "DYNWIN-003"                      , "Kein technisches Deckblatt fr Kernerzeugnis '$1' und Fachgruppe '$2' gefunden." },
    { "DYNWIN-004"                      , "Das Deckblatt mit Gruppennummer '$1' kann nicht als Gruppennummer '$2' kopiert werden." },
    { "DYNWIN-005"                      , "Deckbltter von Vorgang '$1' knnen wegen anderer Deckblatt-Id nicht nach Vorgang '$2' kopiert werden." },
    { "DYNWIN-006"                      , "Anzeige des technischen Deckblattes ist nicht mglich, da fr diesen Vorgang ('$1') bisher kein Kernerzeugnis definiert ist." },
    { "E370-1001"                       , "Fehler im /370-Programm: Binrberlauf" },
    { "E370-1002"                       , "Fehler im /370-Programm: Dezimal-Datenfehler" },
    { "E370-1003"                       , "Fehler im /370-Programm: Dezimal-berlauf" },
    { "E370-1004"                       , "Fehler im /370-Programm: Adressenfehler" },
    { "E370-1005"                       , "Fehler im /370-Programm: Ausrichtungsfehler: ungerade Halbwortadresse" },
    { "E370-1006"                       , "Fehler im /370-Programm: Ausrichtungsfehler fr Wort" },
    { "E370-1007"                       , "Fehler im /370-Programm: Ausrichtungsfehler fr Doppelwort" },
    { "E370-1008"                       , "Fehler im /370-Programm: Ungerades Doppelregister" },
    { "EBO-L001"                        , "Satz mit Schluessel nicht gefunden." },
    { "EBO-L002"                        , "Schluessel bereits vorhanden." },
    { "EBO-L003"                        , "Beim sequentiellen Lesen wurde Dateiende bzw. Dateibeginn erreicht." },
    { "EBO-L005"                        , "Zu loeschender/aendernder Satz wurde von Anwendung nicht gesperrt." },
    { "EBO-L006"                        , "Satz kann nicht gesperrt werden, da bereits durch anderen Anwender gesperrt."   },
    { "EBO-L008"                        , "Der freizugebenden Primaerschuessel kann nicht entsperrt werden, da der Datensatz waehrend der Transaktion geaendert wurde." },
    { "EBO-L009"                        , "Freizugebender Primaerschuessel war nicht gesperrt." },
    { "EBO-L010"                        , "Satzlaengenfehler bei variabler Satzlaenge." },
    { "EBO-L101"                        , "Die angegebene Datei wurde von der Anwendung nicht eroeffnet." },
    { "EBO-L103"                        , "Kein Transaktion eroeffnet." },
    { "EBO-L104"                        , "Die Anmeldung hat sich bereits am Katalog angemeldet." },
    { "EBO-L105"                        , "Dateiname nicht im Katalog definiert." },
    { "EBO-L108"                        , "Ueberlauf der internen LEASY-Verwaltungs-Liste. Von der Anwendung wurden mehr als MAX_EBO_LEASY Dateien und Dateikennungen eroeffnet." },
    { "EBO-L109"                        , "Sekundaerindexname nicht im Katalog definiert" },
    { "EBO-L110"                        , "Server kann eine Datei nicht im gewuenschten Modus eroeffnen, da dieser unvertraeglich mit dem Usage-Modus einer anderen Anwendung ist." },
    { "EBO-L111"                        , "Die Anwendung hat eine Datei bereits SHARED eroeffnet und will sie nun EXCLUSIVE eroeffnen." },
    { "EBO-L113"                        , "Sperrtabelle oder Transaktionstabelle voll" },
    { "EBO-L119"                        , "Die Anwendung will sich vom Katatog abmelden und es ist noch eine Transaktion nicht beendet worden." },
    { "EBO-L122"                        , "Dateikennung bereits eroeffnet" },
    { "EBO-LC02"                        , "Der von der Anwendung uebergebene Katalogname stimmt nicht mit dem im SHM hinterlegten Katalognamen ueberein." },
    { "EBO-LC04"                        , "Anwendung nicht am Katalog angemeldet." },
    { "EBO-LC06"                        , "LEASY-Funktion unbekannt, wird nicht unerstuetzt" },
    { "EBO-LC99"                        , "Ctree-Fehler, RC_LC ist unbedingt auszuwerten" },
    { "EBO-LI05"                        , "IO-Fehler bei Datenbankzugriff. Die Fehlerspezifikation ist der Fehlerergaenzung in RC-LCE zu entnehmen." },
    { "EBO-LP04"                        , "OPE1 / OPE2 nicht zulaessig" },
    { "EBO-LP08"                        , "Falsche Feldauswahl, wenn angegeben: nicht \"MAINITEM\" oder \"ALL \" oder \"(ALL)\"" },
    { "EBO-LP09"                        , "Syntax- oder Formatfehler bei DB-Angabe" },
    { "EBO-LP16"                        , "OPE-OM nicht zulaessig : im DB4-Format ist OPE_OM nicht mit HIGH-Value besetzt." },
    { "EBO-LS01"                        , "IPC-Struktur nicht eingerichtet, Server nicht aktiv." },
    { "EBO-LS02"                        , "Server weist Aufruf wegen shutdown ab." },
    { "EBO-LS04"                        , "IPC-Struktur fuer Anwendung gesperrt" },
    { "EBO-LS05"                        , "Datenbankverbindung ist nicht mehr gltig, weil die Datenbank neu gestartet worden ist" },
    { "EBO-LS09"                        , "Eroeffnung der Folgetransaktion wegen shutdown abgelehnt." },
    { "EBO-LS10"                        , "Operation wegen Shutdown in Rollback" },
    { "EBO-LS23"                        , "Fehler bei Commit" },
    { "EBO-LS40"                        , "Sperrelement nicht gefunden" },
    { "EBO-LS43"                        , "Primaersatz passt nicht zu SI-Satz" },
    { "EBO-LS44"                        , "Strukturfehler in BIM-Datei" },
    { "EBO-LS45"                        , "interne ctree Dateinummer falsch" },
    { "EBO-LS46"                        , "zu hohe interne Fehlernummer" },
    { "EBO-LS47"                        , "Fehler in COMMIT" },
    { "EBO-LS48"                        , "Inkonsiste Daten, Programmfehler RC_LCE ist unbedingt auszuwerten" },
    { "EBO-LS68"                        , "falsche Version" },
    { "EBO-LU01"                        , "Falscher Server-Aufruf" },
    { "FACTORY-101"                     , "Dateiende beim Lesen einer RTF-Verschachtelung" },
    { "FACTORY-110"                     , "Dateiende beim Lesen einer RTF-Verschachtelung" },
    { "FACTORY-111"                     , "Dateiende beim Lesen einer Formatvorlagendefinition" },
    { "FACTORY-112"                     , "Dateiende beim Lesen einer Skript-Anweisung" },
    { "FACTORY-113"                     , "Vorlage ist keine RTF-Datei" },
    { "FACTORY-114"                     , "Das Konstruktur-Objekt (global_object) ist noch nicht von make_script() angelegt worden" },
    { "FACTORY-115"                     , "Das fehlerhafte Dokument ist nur fr RTF verfgbar" },
    { "FACTORY-116"                     , "Die fehlerhafte Stelle ist nicht verfgbar" },
    { "FACTORY-201"                     , "Ausfhrungs-Fehler im Vorlagen-Skript: $1" },
    { "FACTORY-202"                     , "\"..\" im Bausteinnamen ist nicht erlaubt" },
    { "FACTORY-203"                     , "Unbekannte #-Anweisung" },
    { "FACTORY-204"                     , "#include: Skriptdateiname muss in Anfhrungszeichen gesetzt sein" },
    { "FACTORY-205"                     , "#include: Zu tiefe Verschachtelung" },
    { "FACTORY-206"                     , "In einem embed-Baustein sind Skriptanweisungen nicht zulssig" },
    { "FACTORY-207"                     , "In einem embed-Baustein ist #include nicht zulssig" },
    { "FACTORY-208"                     , "Zeichenkette in der Vorlage ist nicht abgeschlossen" },
    { "FACTORY-209"                     , "Skriptanweisung <%...%> in der Vorlage ist nicht abgeschlossen, \"%>\" fehlt" },
    { "FACTORY-210"                     , "$()-Ausdruck in der Zeichenkette ist nicht abgeschlossen" },
    { "FACTORY-211"                     , "Ein RTF-Dokument kann nicht in ein Textdokument eingebettet werden" },
    { "FACTORY-301"                     , "Dokumentparameter $1 ist nicht gesetzt" },
    { "FACTORY-302"                     , "factory_get_parameters() des Serienskripts liefert nicht die Dokumentparameter als Typ hostware.Variables" },
    { "FACTORY-303"                     , "Syntaxfehler in der Wiederanlaufdatei" },
    { "FACTORY-304"                     , "Das Muster $1 fr den Dokumentnamen hat nicht gengend '#', um die laufende Nummer $2 aufzunehmen" },
    { "FACTORY-305"                     , "$1 ist nicht gesetzt und der Konstruktor fr die Verarbeitungsobjekte fehlt" },
    { "FACTORY-306"                     , "processor.add_obj() mit leerem Namen" },
    { "FACTORY-307"                     , "document_filename oder -output= ist nicht gesetzt worden" },
  //{ "FACTORY-401"                     , "kill_all_words: Der Prozess svchost.exe fehlt. Kein Word wird beendet." },

    // Fehler FACTORY-500 bis FACTORY 899 fr COM-Server Document_factory reserviert. s. prod/document_factory/*

    { "FACTORY-900"                     , "Fehler im RTF-Aufbereiter: falsche {}-Verschachtelung" },
    
    { "GHOSTSCRIPT-100"                 , "e_Fatal. gs_interpret also returns this for a .quit with a positive exit code." },
    { "GHOSTSCRIPT-101"                 , "e_Quit. Internal code for the .quit operator. The real quit code is an integer on the operand stack. gs_interpret returns this only for a .quit with a zero exit code." },
    { "GHOSTSCRIPT-102"                 , "e_InterpreterExit. Internal code for a normal exit from the interpreter." },
    { "GHOSTSCRIPT-103"                 , "e_RemapColor. Internal code that indicates that a procedure has been stored in the remap_proc of the graphics state, and should be called before retrying the current token.  This is used for color remapping involving a call back into the interpreter -- inelegant, but effective." },
    { "GHOSTSCRIPT-104"                 , "e_ExecStackUnderflow. of the e-stack. Internal code to indicate we have underflowed the top block." },
    { "GHOSTSCRIPT-105"                 , "e_VMreclaim. Internal code for the vmreclaim operator with a positive operand. We need to handle this as an error because otherwise the interpreter won't reload enough of its state when the operator returns." },
    { "GHOSTSCRIPT-106"                 , "e_NeedInput. Internal code for requesting more input from run_string." },
    { "GHOSTSCRIPT-107"                 , "e_NeedStdin. Internal code for stdin callout." },
    { "GHOSTSCRIPT-108"                 , "e_NeedStdout. Internal code for stdout callout." }, 
    { "GHOSTSCRIPT-109"                 , "e_NeedStderr. Internal code for stderr callout." },
    { "GHOSTSCRIPT-110"                 , "e_Info. Internal code for a normal exit when usage info is displayed. This allows Window versions of Ghostscript to pause until the message can be read." },

    { "INGRES-0836"                     , "Spaltenname in Ingres-Tabelle nicht gefunden." },
    { "INGRES-0845"                     , "Tabellenname nicht gefunden." },
    { "INGRES-1194"                     , "Satz mit diesem Schlssel \"$1\" existiert schon. $2" },
    { "INGRES-125E"                     , "Ingres-Tabelle '' ist momentan gesperrt. Bitte spter versuchen bzw. DBA verstndigen." },
    { "INGRES-97002D"                   , "E_LQ002D Association to the dbms has failed.  This session should be disconnected." },
    { "LEASY-L000"                      , "Funktion wurde ordnungsgem durchgefhrt (bei allen Operationen)" },
    { "LEASY-L001"                      , "Satz mit Schlssel nicht gefunden (RDIR, RHLD, REWR, DLET)" },
    { "LEASY-L002"                      , "Duplikat (RNXT, INSR bei Primr- oder Sekundrschlssel, REWR, STOR bei Sekundrschlssel mit DUPKEY = NO)" },
    { "LEASY-L003"                      , "EOF beim sequentiellen Lesen (fr RNXT und RNHD bei Dateiende, fr RPRI und RPHD bei Dateibeginn) oder Positionierungsfehler:sequentieller Lesebefehl ohne aktuelles Intervall (RNXT, RNHD, RPRI, RPHD) oder EOF bei INSR bei ISAM (USAGE-Modi LOAD/PLOD/ELOD und LDUP/PLUP/ELUP)" },
    { "LEASY-L004"                      , "Folgefehler bei Lademodus (INSR)" },
    { "LEASY-L005"                      , "Satz wurde nicht gesperrt (DLET, REWR)" },
    { "LEASY-L006"                      , "Wartezeit bei Sperrversuch abgelaufen (LOCK, RHLD, RNHD, INSR, STOR)" },
    { "LEASY-L007"                      , "Deadlock bei Sperrversuch (LOCK, RHLD, RNHD, RPHD, INSR, STOR)" },
    { "LEASY-L008"                      , "Freizugebender Satz kann nicht entsperrt werden, da er in der Transaktion gendert wurde (UNLIK)" },
    { "LEASY-L009"                      , "Warnung - freizugebender Satz war nicht gesperrt (UNLK)" },
    { "LEASY-L010"                      , "Satzlngenfehler bei variabler Satzlnge (INSR, REWR, STOR)" },
    { "LEASY-L011"                      , "Warnung - mehr als 255 Stze je Block (RNXT, RPRI; SAM)" },
    { "LEASY-L012"                      , "Kein aktueller Satz vorhanden (REWR; SAM) oder kein gltiger Lesebefehl fr Dateikennung (vor DLET ohne Schlsselangabe)" },
    { "LEASY-L013"                      , "Schlssel auerhalb des zulssigen Bereiches; die hchste PAM-Blocknummer des zu schreibenden Blocks mu -< FILESIZE + SECONDARY ALLOCATION) sein (INSR, STOR; PAM und DAM)" },
    { "LEASY-L014"                      , "Warnung: CLTR/CLSE (OPE=R) - Aufruf in Transkation ohne BIM-Sicherung wirkt wie CLTR" },
    { "LEASY-L015"                      , "UTM: Task-Deadlock" },
    { "LEASY-L016"                      , "Schreiben eines Satzes einer DAM-Datei nicht mglich, da X'FF' im ersten Byte des Datensatzes (Lschkennzeichen fr DAM). (INSR, STOR, REWR)" },
    { "LEASY-L101"                      , "Datei bei OPTR dieser Transaktion nicht angegeben (bei allen Operationen, die im 3. Operanden eine Dateikenning angeben)" },
    { "LEASY-L102"                      , "Unzulssige Operation - Widerspruch zu FCBTYPE und /oder USAGE-Modus (bei allen Operationen, die im 3. Operanden eine Dateikennung angeben)" },
    { "LEASY-L103"                      , "Keine Transaktion erffnet (CLTR, bei allen Operationen, die im 3. Operanden eine Dateikennung angeben)" },
    { "LEASY-L104"                      , "Transaktion erffnet bei CATD bzw. DISCONNECT/UTM" },
    { "LEASY-L105"                      , "Dateiname oder Zusatzname in LEASY-Katalog nicht definiert (OPFL, OPTR)" },
    { "LEASY-L106"                      , "USAGE-Modus mit OPEN-Modus unvertrglich (OPFL nach OPTR)" },
    { "LEASY-L107"                      , "Fr Modelldatei fehlt Zusatzangabe (OPFEL, OPTR)" },
    { "LEASY-L108"                      , "berlauf FILE-Tabelle (OPTR) - Anweisung *FILE bei LEA. Maintask erhhen!" },
    { "LEASY-L109"                      , "Sekundrindexname in LEASY-Katalog nicht gefunden (RDIR, RHLD, SETL)" },
    { "LEASY-L110"                      , "Datei kann nicht mit der geforderten USAGE-Modus bzw. Result-USAGE-Modus nicht erffnet werden, da diese von anderer Transaktion schon mit strkerem USAGE-Modus erffnet ist (OPTR)" },
    { "LEASY-L111"                      , "USAGE-Modus unvertrglich mit bereits erffneter Dateikennung in derselben Transaktion" },
    { "LEASY-L112"                      , "KEYLEN (ISAM-Datei) > KEY-Anweisung bei LEA.MAINTASK (OPTR; ISAM)" },
    { "LEASY-L113"                      , "KEYLEN > 4 bei USAGE-Modi LOAD, ELOD, PLOD, LDUP, PLUP, ELUP (OPTR; ISAM)" },
    { "LEASY-L114"                      , "Satzlnge mit Blocklnge nicht vertrglich oder ungltige BLKSIZE (OPFL, OPTR)" },
    { "LEASY-L115"                      , "In bisherigen OPTR-Operationen dieser Transaktion wurde das geforderte Folgemerkmal fr diese Datei nicht angegeben (bei allen Transaktionen, die im 3. Operanden eine Dateikennung angeben)" },
    { "LEASY-L116"                      , "Kein CLFL durchgefhrt (CATD nach CLFL) oder die Datei ist bereits erffnet (OPFL)" },
    { "LEASY-L117"                      , "Kein CLTR/CLSE durchgefhrt (OPFL nach OPTR)" },
    { "LEASY-L118"                      , "CLFL: mindistens eine der angegebenen Dateien wurde nicht durch OPFL erffnet" },
    { "LEASY-L119"                      , "Kein CLTR/CLSE durchgefhrt (CLFL nach OPTR)" },
    { "LEASY-L120"                      , "Datei (OPTR) nicht in vorangegangener Dateiliste (OPFL) angegeben (OPTR nach OPFL)" },
    { "LEASY-L122"                      , "Dateikennung bereits erffnet" },
    { "LEASY-L123"                      , "AIM-Puffer zu klein gewhlt (*ATB in LEA.MAINTASK) im Verhltnis zu maximaler RECSIZE (OPFL, OPTR) bzw. Warmstart mit LEA.MAINTASK ohne AIM-Sicherung, obwohl fr die rckzurollende Transaktion AIM-Sicherung eingeschaltet war." },
    { "LEASY-L124"                      , "2. OPTR-Aufruf ohne Verwendung von OPFL" },
    { "LEASY-L125"                      , "Inkonsistenz zwischen den Eintragungen im LEASY-Katalog und im DVS-Katalog" },
    { "LEASY-LI01"                      , "IOH-interner Fehler: CATD-Aufruf fehlt (Fremddateien nicht erlaubt)" },
    { "LEASY-LI02"                      , "IOH-interner Fehler: keine Transaktion aktiv (DCAM LU80)" },
    { "LEASY-LI03"                      , "IOH-interner Fehler: berlauf im bergabebereich. Maximalzahl der Anwenderprogramme berschritten" },
    { "LEASY-LI04"                      , "IOH-interner Fehler: Wartezeit auf IO-Task abgelaufen (WAI-Anweisung)" },
    { "LEASY-LI05"                      , "IOH-interner Fehler: IO-Task bei Bearbeitung eines LEASY-Aufrufs fehlerhaft beendet. Transaktion zurckgesetzt" },
    { "LEASY-LI06"                      , "IOH-interner Fehler: IO-Task bei Bearbeitung eines LEASY-Aufrufs fehlerhaft beendet. Transaktion nicht zurckgesetzt" },
    { "LEASY-L107"                      , "IOH-interner Fehler: Initialisierungsfehler. Der Common Memory ist nicht freigegeben" },
    { "LEASY-L108"                      , "IOH-interner Fehler: Versionsfehler. Interne Version mit IO-Task unvertrglich" },
    { "LEASY-L109"                      , "IOH-interner Fehler: Auf Semaphor (geschtzte Variable) kann nicht zugegriffen werden. Fehler bei interner Synchonisation" },
    { "LEASY-LI10"                      , "IOH-interner Fehler: Die Satzlnge im CINF-Bereich ist grer als in der DBL-Anweisung angegeben" },
    { "LEASY-LP01"                      , "Operationscode falsch (bei allen Operationen)" },
    { "LEASY-LP02"                      , "Zu wenig Operanden (bei allen Operationen)" },
    { "LEASY-LP04"                      , "OPE1/OPE2 falsch (CLTR)" },
    { "LEASY-LP05"                      , "LEASY-Systemfehler: Dateianzahl -< 0 oder > 1000 (OPTR, OPFL)" },
    { "LEASY-LP06"                      , "USAGE-Modus falsch oder unzulssig" },
    { "LEASY-LP07"                      , "OPEN-Modus falsch oder unzulssig" },
    { "LEASY-LP08"                      , "Feldauswahl falsch, '(ALL)' (SETL, RDIR, RHLD)" },
    { "LEASY-LP09"                      , "Syntaxfehler, in der Dateiliste (OPFEL, OPTR, CLFL)" },
    { "LEASY-LP10"                      , "Syntaxfehler im Katalognamen (CATD)" },
    { "LEASY-LP11"                      , "CI-Bereich zu klein fr Currency Information (CINF) oder keine Information im CI-Bereich(ci-slf=0)" },
    { "LEASY-LP12"                      , "L-OPT falsch '1' (bei allen Operationen)" },
    { "LEASY-LP14"                      , "PAMHPNR/SAMPTR ungltig (bei allen Operationen, bei denen diese Felder ausgewertet werden)" },
    { "LEASY-LP15"                      , "OPE-WTIME nicht numerisch (bei allen Operationen)" },
    { "LEASY-LP16"                      , "OPE-OM im RE-Bereich falsch besetzt" },
    { "LEASY-LP17"                      , "Ungltige Kombination von (KB, KE) (SETL, RDIR bei SAM-Datei)" },
    { "LEASY-LP18"                      , "Syntaxfehler in Dateikennung (bei allen Operationen mit Angabe von DB1)" },
    { "LEASY-LP19"                      , "OPE-STX falsch (CATD)" },
    { "LEASY-LS01"                      , "Common Memory CMMAIN von MAINTASK fr angegebenen LEASY-Katalog nicht eingerichtet (CATD, OPTR)" },
    { "LEASY-LS02"                      , "Operation wegen CLOS- oder SHUT-Funktion abgelehnt (CATD, OPFl, OPTR)" },
    { "LEASY-LS03"                      , "Zu viele Transaktionen - berlauf Transaktionstabelle (OPTR) Anweisung *USE=R in LEA.MAINTASK)" },
    { "LEASY-LS04"                      , "Common Memory CMMAIN ist fr das Laufzeitsystem gesperrt (*USE=R in LEA.MAINTASK)" },
    { "LEASY-LS05"                      , "Wegen HOLD-Funktion momentan berhaupt keine Operation mglich" },
    { "LEASY-LS06"                      , "Wegen QUIE-Funktion derzeit keine neue Transaktion mglich" },
    { "LEASY-LS07"                      , "Wegen LOCT- oder QUIE-Funktion derzeit keine Operation fr diese Transaktion mglich" },
    { "LEASY-LS09"                      , "Wegen SHUT-, CLOS oder RLBT- Funktion wird bei CLTR-Operationen OPE2=T ignoriert" },
    { "LEASY-LS10"                      , "Operation wegen RLBT- oder SHUT-Funktion in CLTR/CLSE mit OPE1=R umgewandelt" },
    { "LEASY-LS11"                      , "Virtueller Speicher erschpft (bei REQM, ENAMP Makro)" },
    { "LEASY-LS12"                      , "berlauf des Bereichs fr Transaktionselemente (bei OPTR) oder des Bereichs fr Sperrlistenelemente beim Versuch, neues Sperrelement anzulegen Anweisung *MEM bei LEA.MAINTASK erhhen!" },
    { "LEASY-LS13"                      , "Die Datei ist vom Dienstprogramm LEA.MASTER gesperrt (OPFL und OPTR)" },
    { "LEASY-LS14"                      , "Die Datei ist vom Dienstprogramm LEA.MASTER gegen schreibende Erffnung gesperrt (OPFL und OPTR)" },
    { "LEASY-LS15"                      , "berlauf Task-Tabelle, *TSK Operand im Dienstprogramm LEA.MAINTASK erhhen" },
    { "LEASY-LS17"                      , "Fehler bei JV-Funktion" },
    { "LEASY-LS23"                      , "Fehler bei Rollback (CLTR, OPE1=R)" },
    { "LEASY-LS24"                      , "VERIFY fr femde USERID nicht mglich" },
    { "LEASY-LS30"                      , "Fehler beim STXIT-Makro im Modul LEASY" },
    { "LEASY-LS31"                      , "Fehler beim Binden des Moduls LEACON" },
    { "LEASY-LS33"                      , "Fehler beim Makro RELM" },
    { "LEASY-LS35"                      , "Fehler beim Makro ENAMP" },
    { "LEASY-LS36"                      , "Version des Moduls LEACON ist unvertrglich mit der Version des Moduls LEASY" },
    { "LEASY-LS40"                      , "LEASY-Systemfehler: angelegtes Sperrelement nicht mehr gefunden" },
    { "LEASY-LS41"                      , "LEASY-Systemfehler: interne Sperre fr Satzsplitting in Sekundrindexdatei hngengeblieben" },
    { "LEASY-LS42"                      , "LEASY-Systemfehler: Duplikat in Sekkundrindexdatei bei Satzsplitting" },
    { "LEASY-LS43"                      , "Dateiinkonsistenz zwischen Primr- und Sekundrindexdatei: zu SI-Eintrag kein Primrsatz vorhanden oder er enthlt einen falschen Sekundrschlsselwert" },
    { "LEASY-LS44"                      , "Strukturfehler in BIM-Datei (beim Rollback)" },
    { "LEASY-LS45"                      , "LEASY-Systemfehler: Inkonsistenz in Common Memory (interne Sekundrindexnummer nicht gefunden)" },
    { "LEASY-LS46"                      , "LEASY-Systemfehler: zu hohe interne Fehlernummer" },
    { "LEASY-LS47"                      , "LEASY-Systemfehler: Logikfehler in LEAWRAIM" },
    { "LEASY-LS48"                      , "LEASY-Systemfehler: MVC-Sperre hngt in LEAWRAIM" },
    { "LEASY-LS49"                      , "LEASY-Systemfehler: WRT-Sperre hngt in LEAWRAIM" },
    { "LEASY-LS51"                      , "LEASY-Systemfehler: AIM-Puffer ist voll und kann wegen eines Fehlers bei PAM-WRITE nicht entleert werden" },
    { "LEASY-LS52"                      , "Strukturfehler in PAM-Datei" },
    { "LEASY-LS53"                      , "LEASY-Systemfehler: AIMSWITCH-Sperre hngt in LEALAISW" },
    { "LEASY-LS54"                      , "LEASY-Systemfehler: Open-File-Tabellen-Sperre hngt in LEASPERR" },
    { "LEASY-LS55"                      , "LEASY-Systemfehler: Transaktions-Tabellen-Sperre hngt in LEASPERR" },
    { "LEASY-LS56"                      , "LEASY-Systemfehler: Freiketten-Sperre hngt in LEASPERR" },
    { "LEASY-LS57"                      , "LEASY-Systemfehler: Freigabe-Sperre hngt in LEASPERR" },
    { "LEASY-LS58"                      , "LEASY-Systemfehler: Datei-Tabellensperre hngt in LEAFTIN" },
    { "LEASY-LS59"                      , "Fehler beim Schreiben eines DAM-Datenblocks: Fehler bei der SI- oder AIM-Behandlung erzwang einen automatischen Rollback der Transaktion (CLTR, alle Operationen, die im 3. Operanden eine Dateikennung angeben)." },
    { "LEASY-LS60"                      , "LEASY-Systemfehler: Sperre der Deadlock-Bitmatrix hngt" },
    { "LEASY-LS61"                      , "Fehler beim Makro ENAEI" },
    { "LEASY-LS62"                      , "Fehler beim Makro ENACO" },
    { "LEASY-LS63"                      , "Fehler beim Makro SOLSIG" },
    { "LEASY-LS64"                      , "Fehler beim Makro POSSIG" },
    { "LEASY-LS65"                      , "MAINTASK fehlerhaft beendet beim Schreiben des AIM-Puffers auf Band" },
    { "LEASY-LS66"                      , "LEASY-Systemfehler: Fehler beim Verkrzen von AIM-Stzen" },
    { "LEASY-LS67"                      , "LEASY-Systemfehler: falsche Aufrufversorgung fr Modul LEAKMP" },
    { "LEASY-LS68"                      , "Version des Laufzeitsystems ungleich Version des Common Memory CMMAIN" },
    { "LEASY-LS69"                      , "Fehler beim Makro DISMP" },
    { "LEASY-LS70"                      , "Fehler beim Makro DISEI" },
    { "LEASY-LS71"                      , "Fehler beim Makro CREPOOL (fr NKISAM)" },
    { "LEASY-LS72"                      , "Fehler beim Makro DELPOOL (fr NKISAM)" },
    { "LEASY-LS73"                      , "Fehler beim Makro ADDPLNK (fr NKISAM)" },
    { "LEASY-LS74"                      , "Fehler beim Makro REMPLNK (fr NKISAM)" },
    { "LEASY-LU01"                      , "UTM: falscher Startoperand" },
    { "LEASY-LU02"                      , "UTM: Syntaxfehler bei Startoperand" },
    { "LEASY-LU10"                      , "UTM: keine oder zuwenig Startoperanden DCAM: Fehler in der Operationsfolge beim Start (CATD und/oder OFPL fehlen)" },
    { "LEASY-LU11"                      , "UTM/DCAM: weniger als 2 LEASY-Operanden" },
    { "LEASY-LU12"                      , "UTM/DCAM: Open-Modus unzulssig fr Fremd- oder SAM-Datei (Datei darf nur gelesen werden) (OPFL)" },
    { "LEASY-LU13"                      , "UTM/DCAM: LEASY-Temporrdatei verboten (OPFL)" },
    { "LEASY-LU14"                      , "UTM: nach verzgertem CLTR/CLSE kein CALL-LEASY im selben Dialogschritt erlaubt (alle Operationen)" },
    { "LEASY-LU15"                      , "UTM: In Transaktionen ohne BIM-Sicherung darf Datei nicht zum Schreiben erffnet werden (OPTR)" },
    { "LEASY-LU16"                      , "DCAM: Fehler. fehler in der Intertask-Synchronisation fr OPFL bzw. CLFL oder unterschiedliche Reihenfolge bei OPFL" },
    { "LEASY-LU17"                      , "DCAM: Fehler. Offene Transaktion innerhalb der DCAM-Anwendung bei OPFL oder CLFL" },
    { "LEASY-LU18"                      , "DCAM: Fehler. Transaktion kann nicht gleichzeitig in mehreren Tasks ativ sein" },
    { "LEASY-LU50"                      , "UTM/DCAM: berlauf Anwendungstabelle" },
    { "LEASY-LU51"                      , "UTM/DCAM: Inkonsistenz in der Anwendungstabelle" },
    { "LEASY-LU52"                      , "UTM/DCAM: interne Sperre der Anwendungstabelle ist hngengeblieben" },
    { "LEASY-LU54"                      , "UTM: Status-Abfrage zur aktuellen LEASY-Session mit noch offenen Transaktionen der UTM-Anwendung" },
    { "LEASY-LU80"                      , "UTM: Fehler in der UTM-Aufruffolge: BIB-Aufruf fehlt bei Taskwechsel DCAM: DCAM-Anwendungsname fehlt (CATD) Tansaktions-Identifikation fehlt oder ist fehlerhaft (bei allen Operationen innerhalb einer LEASY-Transaktion)" },
    { "LEASY-LU81"                      , "UTM: OPFL-Aufruf fehlt (OPTR)" },
    { "LEASY-LU82"                      , "UTM: Startoperand beginnt nicht mit \".LEASY_\"" },
    { "LEASY-LU83"                      , "UTM: Operationscode falsch" },
    { "LEASY-LU84"                      , "UTM: Status Aufruf: Operationscode weder \"Abfrage\" noch \"Lschen\"" },
    { "LEASY-LU85"                      , "UTM: Fehler bei der Behandlung vorlufig beendeter Transaktionen" },
    { "LIB01"                           , "source/macro library: der Stammsatz ist ungueltig" },
    { "LIB03"                           , "source/macro library: die Bibliothek ist nicht vom gefordertem Typ" },
    { "LIB11"                           , "Source/macro library: \" END-DIRECTORY\" vermisst" },
    { "LIB14"                           , "Source/macro library: Schluesselueberlauf im Directory" },
    { "LIB15"                           , "LMS/Macro Library: erster Satz des zu entfernenden (alten) Members fehlt - wird ignoriert" },
    { "LIB20"                           , "Zur Zeit wird schon ein Dokument in diese Bibliothek geschrieben" },
    { "LIB21"                           , "Nur bei \"longname\" kann im Dokumentverzeichnis positioniert werden" },
    { "M000"                            , "Die Mailbox laeuft nicht" },
    { "M001"                            , "Mailbox-Fehler: MACOWHAT ist ungueltig" },
    { "M010"                            , "Mailbox-Fehler: SEND: die Anweisungslaenge stimmt nicht" },
    { "M011"                            , "Mailbox-Fehler: Buffer-Laenge stimmt nicht" },
    { "M012"                            , "Mailbox-Fehler: ungueltige Satzlaenge" },
    { "M040"                            , "Die Mailbox ist nicht mehr aktiv" },
    { "M050"                            , "Die Ereignissteuerung ist bereits eingeschaltet" },
    { "M051"                            , "Die Ereignissteuerung ist nicht eingeschaltet" },
    { "M052"                            , "FOXET: Die Variable fuer den FOX-Dokumentnamen ist zu klein" },
    { "M060"                            , "FOX GET-GROUP: Variable fuer Benutzergruppe ist zu klein" },
    { "M061"                            , "FOX ADD-GROUP: Liste der Benutzer ist falsch aufgebaut" },
    { "M080"                            , "Die ID vom Anwenderprogramm fuer die Mailbox ist ungueltig" },
    { "M081"                            , "Die ID vom Anwenderprogramm fuer die Mailbox ist ungueltig. Sie gehoert einem anderen Anwender" },
    { "M100"                            , "Der Benutzer ist nicht bekannt" },
    { "M101"                            , "Ein Benutzer mit dem Kurznamen ist bereits eingetragen" },
    { "M102"                            , "Das Password ist falsch (oder der Benutzername fuer Fox stimmt nicht)" },
    { "M103"                            , "Ein Benutzereintrag darf nur vom Benutzer oder Verwalter geaendert werden" },
    { "M104"                            , "Es darf nicht mehr als ein Benutzer privilegiert sein" },
    { "M105"                            , "Nur ein privilegierter Benutzer darf die Passwords anderer Benutzer lesen" },
    { "M109"                            , "Der Benutzername ist nicht angegeben" },
    { "M110"                            , "Benutzer ist bereits angemeldet" },
    { "M111"                            , "In einer Benutzergruppe darf keine Gruppe enthalten sein" },
    { "M112"                            , "Der Name ist fuer eine Benutzergruppe vergeben" },
    { "M120"                            , "Das Datum ist nicht in der Form yymmddhhmmss angegeben" },
    { "M130"                            , "Es sind noch Dokumente da. Der Benutzer kann nicht entfernt werden" },
    { "M200"                            , "Fuer Sie ist Post da" },
    { "M201"                            , "Fuer Sie ist keine Post da" },
    { "M202"                            , "Fuer Sie ist keine neue Post da" },
    { "M210"                            , "Das Dokument ist nicht (mehr) da" },
    { "M211"                            , "Das Dokument ist noch nicht vollstaendig in der Mailbox. Spaeter versuchen" },
    { "M212"                            , "Das Dokument wird gerade gelesen und kann daher nicht entfernt werden" },
    { "M213"                            , "Kein unbekanntes FOX-Dokument ist da. Alle Namen sind schon gezeigt worden" },
    { "M214"                            , "Auf das Dokument wird eine Antwort erwartet" },
    { "M215"                            , "Auf Dokumente eines anderen Benutzers duerfen Sie nicht zugreifen" },
    { "M216"                            , "Die Antwort kann nur an den Absender zurueckgeschickt werden" },
    { "M217"                            , "Das zu beantwortende Dokument gibt es nicht" },
    { "M218"                            , "Das Dokument ist dem Empfaenger schon bekannt, kann daher nicht entfernt werden" },
    { "M219"                            , "Zuviele Empfaenger aufeinmal" },
    { "M220"                            , "Zu dem Dokument kann keine Antwort gegeben werden" },
    { "M221"                            , "Zu dem Dokument gibt es keine Antwort" },
    { "M222"                            , "Zu dem Dokument gibt es keine Anfrage" },
    { "M223"                            , "FOX SET-STATUS: Status kann nur im empfangenen Dokument gesetzt werden" },
    { "M224"                            , "Ein empfangenes Dokument kann nicht storniert werden" },
    { "M225"                            , "Das Dokument wird nicht storniert, weil es schon gelesen worden ist" },
    { "M701"                            , "Das Dokument ist abgeschickt" },
    { "MSWIN-DDE-0000"                  , "DDE-Server ist nicht gestartet? (nicht dokumentierter Fehler)" },
    { "MSWIN-DDE-4000"                  , "DMLERR_ADVACKTIMEOUT  A request for a synchronous advise transaction has timed out." },
    { "MSWIN-DDE-4001"                  , "DMLERR_BUSY  The response to the transaction caused the DDE_FBUSY flag to be set." },
    { "MSWIN-DDE-4002"                  , "DMLERR_DATAACKTIMEOUT  A request for a synchronous data transaction has timed out." },
    { "MSWIN-DDE-4003"                  , "DMLERR_DLL_NOT_INITIALIZED  A DDEML function was called without first calling the DdeInitialize function, or an invalid instance identifier was passed to a DDEML function." },
    { "MSWIN-DDE-4004"                  , "DMLERR_DLL_USAGE  An application initialized as APPCLASS_MONITOR has attempted to perform a dynamic data exchange (DDE) transaction, or an application initialized as APPCMD_CLIENTONLY has attempted to perform server transactions." },
    { "MSWIN-DDE-4005"                  , "DMLERR_EXECACKTIMEOUT  A request for a synchronous execute transaction has timed out" },
    { "MSWIN-DDE-4006"                  , "DMLERR_INVALIDPARAMETER" },
    { "MSWIN-DDE-4007"                  , "DMLERR_LOW_MEMORY  A DDEML application has created a prolonged race condition (in which the server application outruns the client), causing large amounts of memory to be consumed" },
    { "MSWIN-DDE-4008"                  , "DMLERR_MEMORY_ERROR  A memory allocation has failed" },
    { "MSWIN-DDE-4009"                  , "DMLERR_NOTPROCESSED  A transaction has failed" },
    { "MSWIN-DDE-400A"                  , "DMLERR_NO_CONV_ESTABLISHED  A client's attempt to establish a conversation has failed" },
    { "MSWIN-DDE-400B"                  , "DMLERR_POKEACKTIMEOUT  A request for a synchronous poke transaction has timed out" },
    { "MSWIN-DDE-400C"                  , "DMLERR_POSTMSG_FAILED  An internal call to the PostMessage function has failed" },
    { "MSWIN-DDE-400D"                  , "DMLERR_REENTRANCY  An application instance with a synchronous transaction already in progress attempted to initiate another synchronous transaction, or the DdeEnableCallback function was called from within a DDEML callback function" },
    { "MSWIN-DDE-400E"                  , "DMLERR_SERVER_DIED  A server-side transaction was attempted on a conversation terminated by the client, or the server terminated before completing a transaction" },
    { "MSWIN-DDE-400F"                  , "DMLERR_SYS_ERROR  An internal error has occurred in the DDEML" },
    { "MSWIN-DDE-4010"                  , "DMLERR_UNADVACKTIMEOUT  A request to end an advise transaction has timed out" },
    { "MSWIN-DDE-4011"                  , "DMLERR_UNFOUND_QUEUE_ID  An invalid transaction identifier was passed to a DDEML function. Once the application has returned from an XTYP_XACT_COMPLETE callback, the transaction identifier for that callback function  is no longer valid" },
    { "MSWIN-GetProcAddress"            , "Routine $1 ist nicht in der DLL $2" },
    { "MSWIN-Global16PointerAlloc-1"    , "WM32_Invalid_Func" },
    { "MSWIN-Global16PointerAlloc-2"    , "WM32_Invalid_Flags"    },
    { "MSWIN-Global16PointerAlloc-3"    , "WM32_Invalid_Arg" },
    { "MSWIN-Global16PointerAlloc-4"    , "WM32_Insufficient_Sels" },
    { "MSWIN-Global16PointerAlloc-5"    , "WM32_Insufficient_Mem" },
    { "MSWIN-Global16PointerFree-1"     , "WM32_Invalid_Func" },
    { "MSWIN-Global16PointerFree-2"     , "WM32_Invalid_Flags" },
    { "MSWIN-Global16PointerFree-3"     , "WM32_Invalid_Arg" },
    { "MSWIN-Global16PointerFree-4"     , "WM32_Insufficient_Sels" },
    { "MSWIN-Global16PointerFree-5"     , "WM32_Insufficient_Mem" },
    { "MSWIN-LoadLibrary-0"             , "$1: System was out of memory, executable file was corrupt, or relocations were invalid." },
    { "MSWIN-LoadLibrary-10"            , "$1: Windows version was incorrect." },
    { "MSWIN-LoadLibrary-11"            , "$1: Executable file was invalid. Either it was not a Windows application or there was an error in the .EXE image." },
    { "MSWIN-LoadLibrary-12"            , "$1: Application was designed for a different operating system." },
    { "MSWIN-LoadLibrary-13"            , "$1: Application was designed for MS-DOS 4.0." },
    { "MSWIN-LoadLibrary-14"            , "$1: Type of executable file was unknown." },
    { "MSWIN-LoadLibrary-15"            , "$1: Attempt was made to load a real-mode application (developed for an earlier version of Windows)." },
    { "MSWIN-LoadLibrary-16"            , "$1: Attempt was made to load a second instance of an executable file containing multiple data segments that were not marked read-only." },
    { "MSWIN-LoadLibrary-19"            , "$1: Attempt was made to load a compressed executable file. The file must be decompressed before it can be loaded." },
    { "MSWIN-LoadLibrary-2"             , "$1: File was not found." },
    { "MSWIN-LoadLibrary-20"            , "$1: Dynamic-link library (DLL) file was invalid. One of the DLLs required to run this application was corrupt." },
    { "MSWIN-LoadLibrary-21"            , "$1: Application requires 32-bit extensions." },
    { "MSWIN-LoadLibrary-3"             , "$1: Path was not found." },
    { "MSWIN-LoadLibrary-5"             , "$1: Attempt was made to dynamically link to a task, or there was a sharing or network-protection error." },
    { "MSWIN-LoadLibrary-6"             , "$1: Library required separate data segments for each task." },
    { "MSWIN-LoadLibrary-8"             , "$1: There was insufficient memory to start the application." },
    { "MT940-001"                       , "$1 fehlt im MT940-Datenstrom" },
    { "MT940-002"                       , "$1 strt im MT940-Datenstrom" },
    { "MT940-003"                       , "Nicht erkannte Zeichen am Ende des MT940-Datenstroms" },
    { "MT940-004"                       , "Unbekannter Block {$1:...}" },
    { "MT940-005"                       , "$1 Zeichen erwartet" },
    { "OLE-CLSIDFromProgID-80040151"    , "REGDB_E_WRITEREGDB  An error occurred writing the CLSID to the registry." },
    { "OLE-CLSIDFromProgID-800401F3"    , "CO_E_CLASSSTRING  The registered CLSID for the ProgID $1 is invalid." },
    { "OLE-CoCreateInstance-80040110"   , "CLASS_E_NOAGGREGATION  class $1 cannot be created as part of an aggregate." },
    { "OLE-CoCreateInstance-80040154"   , "REGDB_E_CLASSNOTREG  class $1 is not registered in the registration database. Also can indicate that the type of server you requested in the CLSCTX enumeration is not registered or the values for the server types in the registry are corrupt." },
    { "ODBC-01000"                      , "General warning." },
    { "ODBC-01002"                      , "Disconnect error." },
    { "ODBC-01004"                      , "Data truncated." },
    { "ODBC-01006"                      , "Privilege not revoked." },
    { "ODBC-01S00"                      , "Invalid connection string attribute." },
    { "ODBC-01S01"                      , "Error in row." },
    { "ODBC-01S02"                      , "Option value changed." },
    { "ODBC-01S03"                      , "No rows updated or deleted." },
    { "ODBC-01S04"                      , "More than one row updated or deleted." },
    { "ODBC-07001"                      , "Wrong number of parameters." },
    { "ODBC-07006"                      , "Restricted data type attribute violation." },
    { "ODBC-08001"                      , "Unable to connect to data source." },
    { "ODBC-08002"                      , "Connection in use." },
    { "ODBC-08003"                      , "Connection not open." },
    { "ODBC-08004"                      , "Data source rejected establishment of connection." },
    { "ODBC-08007"                      , "Connection failure during transaction." },
    { "ODBC-08S01"                      , "Communication link failure." },
    { "ODBC-21S01"                      , "Insert value list does not match column list." },
    { "ODBC-21S02"                      , "Degree of derived table does not match column list." },
    { "ODBC-22001"                      , "String data right truncation." },
    { "ODBC-22003"                      , "Numeric value out of range." },
    { "ODBC-22005"                      , "Error in assignment." },
    { "ODBC-22008"                      , "Datetime field overflow." },
    { "ODBC-22012"                      , "Division by zero." },
    { "ODBC-22026"                      , "String data, length mismatch." },
    { "ODBC-23000"                      , "Integrity constraint violation." },
    { "ODBC-24000"                      , "Invalid cursor state." },
    { "ODBC-25000"                      , "Invalid transaction state." },
    { "ODBC-28000"                      , "Invalid authorization specification." },
    { "ODBC-34000"                      , "Invalid cursor name." },
    { "ODBC-37000"                      , "Syntax error or access violation." },
    { "ODBC-3C000"                      , "Duplicate cursor name." },
    { "ODBC-40001"                      , "Serialization failure." },
    { "ODBC-42000"                      , "Syntax error or access violation." },
    { "ODBC-70100"                      , "Operation aborted." },
    { "ODBC-IM001"                      , "Driver does not support this function." },
    { "ODBC-IM002"                      , "Data source not found and no default driver specified." },
    { "ODBC-IM003"                      , "Specified driver could not be loaded." },
    { "ODBC-IM004"                      , "Driver's SQLAllocEnv failed." },
    { "ODBC-IM005"                      , "Driver's SQLAllocConnect failed." },
    { "ODBC-IM006"                      , "Driver's SQLSetConnect-Option failed." },
    { "ODBC-IM007"                      , "No data source or driver specified; dialog prohibited." },
    { "ODBC-IM008"                      , "Dialog failed." },
    { "ODBC-IM009"                      , "Unable to load translation DLL." },
    { "ODBC-IM010"                      , "Data source name too long." },
    { "ODBC-IM011"                      , "Driver name too long." },
    { "ODBC-IM012"                      , "DRIVER keyword syntax error." },
    { "ODBC-S0001"                      , "Base table or view already exists." },
    { "ODBC-S0002"                      , "Table or view not found." },
    { "ODBC-S0011"                      , "Index already exists." },
    { "ODBC-S0012"                      , "Index not found." },
    { "ODBC-S0021"                      , "Column already exists   The argument szSqlStr contained an ALTER TABLE statement and the column specified in the ADD clause is not unique or identifies an existing column in the base table." },
    { "ODBC-S0022"                      , "Column not found." },
    { "ODBC-S0023"                      , "No default for column." },
    { "ODBC-S1000"                      , "General error." },
    { "ODBC-S1001"                      , "Memory allocation failure." },
    { "ODBC-S1002"                      , "Invalid column number." },
    { "ODBC-S1003"                      , "Program type out of range." },
    { "ODBC-S1004"                      , "SQL data type out of range." },
    { "ODBC-S1008"                      , "Operation canceled." },
    { "ODBC-S1009"                      , "Invalid argument value." },
    { "ODBC-S1010"                      , "Function sequence error." },
    { "ODBC-S1011"                      , "Operation invalid at this time." },
    { "ODBC-S1012"                      , "Invalid transaction operation code." },
    { "ODBC-S1015"                      , "No cursor name available." },
    { "ODBC-S1090"                      , "Invalid string or buffer length." },
    { "ODBC-S1091"                      , "Descriptor type out of range." },
    { "ODBC-S1092"                      , "Option type out of range." },
    { "ODBC-S1093"                      , "Invalid parameter number." },
    { "ODBC-S1094"                      , "Invalid scale value." },
    { "ODBC-S1095"                      , "Function type out of range." },
    { "ODBC-S1096"                      , "Information type out of range." },
    { "ODBC-S1097"                      , "Column type out of range." },
    { "ODBC-S1098"                      , "Scope type out of range." },
    { "ODBC-S1099"                      , "Nullable type out of range." },
    { "ODBC-S1100"                      , "Uniqueness option type out of range." },
    { "ODBC-S1101"                      , "Accuracy option type out of range." },
    { "ODBC-S1103"                      , "Direction option out of range." },
    { "ODBC-S1104"                      , "Invalid precision value." },
    { "ODBC-S1105"                      , "Invalid parameter type." },
    { "ODBC-S1106"                      , "Fetch type out of range." },
    { "ODBC-S1107"                      , "Row value out of range." },
    { "ODBC-S1108"                      , "Concurrency option out of range." },
    { "ODBC-S1109"                      , "Invalid cursor position." },
    { "ODBC-S1110"                      , "Invalid driver completion." },
    { "ODBC-S1111"                      , "Invalid bookmark value." },
    { "ODBC-S1C00"                      , "Driver not capable." },
    { "ODBC-S1T00"                      , "Timeout expired." },
    { "R010"                            , "Stack overflow. Datenstack ist zu klein oder endlose Rekursion" },
    { "R011"                            , "Ungueltiger Wert fuer @CASE" },
    { "R020"                            , "Programmabbruch (Zeitablauf oder Prozessabbruch)" },
    { "R030"                            , "Der Adressierungsmodus (AMODE 24/31) ist nicht kompatibel" },
    { "R090"                            , "Fehler bei USRSHARE: Modul konnte nicht geladen werden (s. Systemmeldung)" },
    { "R100"                            , "Betriebssystem: ungenuegend virtueller Speicher vorhanden" },
    { "R110"                            , "Fehler vom Betriebssystem beim Einrichten eines Segments" },
    { "R111"                            , "Fehler vom Betriebssystem beim Aufloesen eines Segments" },
    { "R112"                            , "Fehler vom BS beim Anfordern virtuellen Speichers f. Datenbereichstabelle" },
    { "R113"                            , "Fehler vom Betriebssystem beim Anfordern virtuellen Speichers" },
    { "R114"                            , "Fehler vom Betriebssystem beim Freigeben virtuellen Speichers" },
    { "R120"                            , "Das Segment fuer die Datenbereichstabelle ist voll" },
    { "R121"                            , "Zu viele Datenbereiche sind angefordert (mehr als 32000)" },
    { "R122"                            , "Speicher fuer dieses Segment ist bereits vollstaendig angefordert" },
    { "R123"                            , "Fuer das Segment soll mehr Speicher freigegeben werden als da ist" },
    { "R124"                            , "Angeforderter Datenbereich ist zu gross (groesser als 192 KB)" },
    { "R130"                            , "DAREQ: Ungenuegend virtueller Speicher verfuegbar" },
    { "R131"                            , "DAREQ: Ungueltige Groesse" },
    { "R132"                            , "DAREQ: Zu viele Datenbereiche (Tabellenueberlauf)" },
    { "R133"                            , "DALNK/DAUNL/DAREL: ungueltige Datenbereichs-ID" },
    { "R134"                            , "Datenbereich/Objekt ist aufgeloest worden oder ID ist ungueltig" },
    { "R135"                            , "Ungueltige ID (Datenbereichs-ID)" },
    { "R150"                            , "Hinweis: interne Tabelle fuer Datenbereichsdeskriptoren ist voll (DFDAT)" },
    { "R151"                            , "DFDAT DELETE: der Datenbereich ist nicht mit DFDAT deklariert worden" },
    { "R152"                            , "DADCL RELEASE: der Datenbereich ist nicht mit DADCL deklariert worden" },
    { "R155"                            , "@RELM (Speicherfreigabe): die Adresse ist nicht auf Seitengrenze" },
    { "R156"                            , "@RELM (Speicherfreigabe): die Adresse stammt nicht von @REQM" },
    { "R200"                            , "Die Operation ist durch den kunden-spezifischen Exit gesperrt" },
    { "R201"                            , "Fehlerhaftes Kommando an den kunden-spezifischen Exit" },
    { "R210"                            , "CRCAL/CRRESUME: Coroutine ist terminiert" },
    { "R211"                            , "CRDETACH ist hier nicht moeglich (kein CRCAL oder CRNEW)" },
    { "R220"                            , "Das Programm BATCH kann nur in einer schreibenden Pipe (>) benutzt werden" },
    { "R221"                            , "Keine Ausgaben des Programm mehr moeglich, weil es geschlossen worden ist" },
    { "R240"                            , "CRCAL/CRRESUME: die Coroutine ist bereits terminiert" },
    { "R250"                            , "- Fehlermeldungen fuer Tasking - Einrichten/Starten" },
    { "R260"                            , "@WAIT: Das Ereignis ist nicht waehrend der Wartezeit eingetroffen" },
    { "R261"                            , "@WAIT: Ereignisbereich wurde waehrend der Wartezeit mit ETDIS aufgeloest" },
    { "R262"                            , "@WAIT: Warteschlange enthaelt nur Anforderungen auf bestimmte Ereignisse" },
    { "R263"                            , "@WAIT: Warteschlange enthaelt nur Anforderungen auf unbestimmte Ereignisse" },
    { "R280"                            , "PRCEXIST ENABLE: Der Partner-Prozess ist nicht (mehr) vorhanden" },
    { "R281"                            , "MUTACAL: Stoerung in der Kommunikation beim Remote Procedure Call" },
    { "R290"                            , "MUTASKSW: Die Unterbrechung kann nicht zugeordnet werden" },
    { "R291"                            , "MUTAINIT: Fehler bei EVCAL ETINIT. Tasking kann nicht initialisiert werden" },
    { "R292"                            , "Fehler bei Anforderung eines Ereignisses vom Betriebssystem: EVCAL ETREQ" },
    { "R293"                            , "Fehler beim Setzen des Zeitgebers des Betriebssystem: EVCAL TIMER" },
    { "R294"                            , "Tasking-Semaphore ist aktiv, obwohl sie nicht aktiv sein darf (MUTALOCK)" },
    { "R301"                            , "GTPAR: der Parameter ist laenger als die aufnehmende Variable" },
    { "R302"                            , "GTPAR: ungueltiger Parametertyp" },
    { "R350"                            , "+++ bis R399: Graphenverwaltung +++" },
    { "R351"                            , "GRAPHDCL: unsortierte Liste ohne Rueckkettung nur als LIFO-Queue moeglich" },
    { "R359"                            , "GRAPHDEL: der aufzuloesende Graph ist nicht leer" },
    { "R360"                            , "DAFND: Vergleich mit Vorzeichen nur bei 2 oder 4 Byte langen Werten" },
    { "R601"                            , "Ungueltige Zahl, beginnt nicht mit einer Ziffer" },
    { "R602"                            , "Der Zahlenbetrag ist zu gross (groesser als 2**31-1). Integer overflow" },
    { "R603"                            , "Ueberlauf beim Hochzaehlen einer langen vorzeichenlosen Zahl (LONGINCR)" },
    { "R610"                            , "Der Wert des Attributs ist zu lang" },
    { "R611"                            , "Der Wert des Attributs fehlt" },
    { "R620"                            , "MUCOMPRS (Komprimierung): Der String ist laenger als das Ergebnisfeld" },
    { "R701"                            , "Der Druckertreiber ist nicht bekannt" },
    { "R710"                            , "Benutzereingabe am Terminal ist zu lang" },
    { "R711"                            , "Ausgabe zum Terminal ist zu lang" },
    { "RU01"                            , "Ungueltige Applikations-ID (Fileserver)" },
    { "RU02"                            , "Ungueltige Benutzer-ID (Benutzer im Fileserver abgemeldet?)" },
    { "RU03"                            , "Ungueltige Objekt-ID (Fileserver)" },
    { "RU11"                            , "Die Applikation ist nicht angemeldet" },
    { "RU12"                            , "Der Benutzer ist nicht angemeldet" },
    { "RU13"                            , "Das Objekt ist nicht geoeffnet" },
    { "RU20"                            , "Der Benutzername ist zu lang" },
    { "RU30"                            , "Der Benutzer ist bereits angemeldet" },
    { "SAACKE-KAK001"                   , "Eingabe der Leitauftrags-Nr. fehlt" },
    { "SAACKE-KAK005"                   , "Gewhrleistungs-Auftrag kann kein Leitauftrag sein" },
    { "SAACKE-KAK010"                   , "Lschen Kopf nicht mehr mglich, da bereits Position vorhanden" },
    { "SAACKE-KAK015"                   , "Eingabe 1. Stelle der Auftrags-Klassifikation. nicht V/W" },
    { "SAACKE-KAK020"                   , "Bei 1.Stelle Klassifikation. = V nur N/A/U/D/G IN 2. Stelle erlaubt" },
    { "SAACKE-KAK021"                   , "Bei 1.Stelle Klassifikation. = W nur F/W/P/C   IN 2. Stelle erlaubt" },
    { "SAACKE-KAK025"                   , "Eingabe 3. Stelle DER Auftr.-Klassifikation. nicht numerisch" },
    { "SAACKE-KAK030"                   , "Bei 1.Stelle Klassifikation. = V fehlt DIE Eingabe AB 4.Stelle" },
    { "SAACKE-KAK031"                   , "Bei 1.Stelle Klassifikation. = V hat 4./5.Stelle unzulssiges LKZ/GST" },
    { "SAACKE-KAK032"                   , "Bei 1.Stelle Klassifikation. =W ist die Eingabe ab 4.Stelle nicht numerisch" },
    { "SAACKE-KAK035"                   , "Eingegebene Prioritt nicht gespeichert" },
    { "SAACKE-KAK037"                   , "Liefertermin (ab Werk) falsch" },
    { "SAACKE-KAK043"                   , "Bei 1.Stelle Klassifikation.=V und Leitauftrag Statistikdaten eingeben" },
    { "SAACKE-KAK044"                   , "Bei 1.Stelle Klassifikation.=W und Leitauftrag Statistikdaten unzulssig" },
    { "SAACKE-KAK047"                   , "Fachgruppe nicht berechtigt, Anlagen-/Werksauftrag zu verwalten" },
    { "SAACKE-KAK048"                   , "Eingegebener Projekt-Ingenieur unzulssig" },
    { "SAACKE-KAK051"                   , "Kunden-Nr. fehlt" },
    { "SAACKE-KAK053"                   , "Rechnungsempfnger fehlt" },
    { "SAACKE-KAK056"                   , "Zolltarif-Nr. fehlt" },
    { "SAACKE-KAK060"                   , "Auftragswert fehlt" },
    { "SAACKE-KAK061"                   , "Vertriebs-Ingenieur 1 fehlt" },
    { "SAACKE-KAK064"                   , "Menge fr Kernerzeugnis fehlt" },
    { "SAACKE-KAK065"                   , "Kernerzeugnis nicht gespeichert" },
    { "SAACKE-KAK069"                   , "Wrme-Erzeuger nicht gespeichert" },
    { "SAACKE-KAK071"                   , "Aufstellgebiet fehlt" },
    { "SAACKE-KAK072"                   , "Aufstellgebiet nicht gespeichert" },
    { "SAACKE-KAK074"                   , "Grob-Erls Lieferung und/oder Montage fehlt" },
    { "SAACKE-KAK076"                   , "Kundenart des Bestellers nicht gespeichert" },
    { "SAACKE-KAK079"                   , "Kundenart des Zahlers nicht gespeichert" },
    { "SAACKE-KAK082"                   , "Angebots-Basis-Nr. = Null und Zhl-Nr. > Null" },
    { "SAACKE-KAK084"                   , "Angebots-Nr. fehlt, aber Angebots-Klassifikation vorhanden" },
    { "SAACKE-KAK086"                   , "Angebots-Klassifikation fehlt, aber Angebots-Nr. vorhanden" },
    { "SAACKE-KAK088"                   , "Summe der Prozentstze zu VI1 + VI2 + VI3 nicht 100" },
    { "SAACKE-KAK090"                   , "Vertriebs-Ingenieur 1 nicht gespeichert" },
    { "SAACKE-KAK092"                   , "Profit-Center ZU Vertriebs-Ingenineur 1 nicht gespeichert" },
    { "SAACKE-KAK093"                   , "Vertriebs-Ingenieur 2 nicht gespeichert" },
    { "SAACKE-KAK093"                   , "Profit-Center ZU Vertriebs-Ingenieur 2 nicht gespeichert" },
    { "SAACKE-KAK096"                   , "Vertriebs-Ingenieur 3 nicht gespeichert" },
    { "SAACKE-KAK098"                   , "Profit-Center ZU Vertriebs-Ingenieur 3 nicht gespeichert" },
    { "SAACKE-KAK100"                   , "Prozent-Anteil zum Vertriebs-Ingenieur1 fehlt" },
    { "SAACKE-KAK102"                   , "Prozent-Anteil zum eingegebenen Vertriebs-Ingenieur 2 fehlt" },
    { "SAACKE-KAK104"                   , "Vertriebs-Ingenieur2 zum eingegebenen Prozent-Anteil fehlt" },
    { "SAACKE-KAK106"                   , "Prozent-Anteil zum eingegebenen Vertriebs-Ingenieur 3 fehlt" },
    { "SAACKE-KAK108"                   , "Vertriebs-Ingenieur 3 zum eingegebenen Prozent-Anteil fehlt" },
    { "SAACKE-KAK114"                   , "Vertriebs-Ingenieur 2 mu ungleich Vertriebs-Ingenieur 1 sein" },
    { "SAACKE-KAK116"                   , "Vertriebs-Ingenieur 3 mu ungleich Vertriebs-Ingenieur 1 sein" },
    { "SAACKE-KAK118"                   , "Vertriebs-Ingenieur 3 mu ungleich Vertriebs-Ingenieur 2 sein" },
    { "SAACKE-KAK176"                   , "Sachbearbeiter-Diktatzeichen fehlt" },
    { "SAACKE-KAK205"                   , "Auftrag bereits gestoppt" },
    { "SAACKE-KAK206"                   , "Auftrag nicht storniert" },
    { "SAACKE-KAK207"                   , "Auftrag nicht gestoppt" },
    { "SAACKE-KAK208"                   , "Verwaltung unzulssig, da Kopfstatus = 8" },
    { "SAACKE-KAK209"                   , "Auftrag bereits storniert" },
    { "SAACKE-KAP002"                   , "Benennung 1 fehlt" },
    { "SAACKE-KAP004"                   , "Beschaffungsart (BA) nicht 1/2/7/8" },
    { "SAACKE-KAP005"                   , "Auftrag zur eingegebenen Position nicht vorhanden" },
    { "SAACKE-KAP006"                   , "Mengeneinheit (ME) nicht gespeichert" },
    { "SAACKE-KAP010"                   , "Positions-Neuanlage nicht zulssig, weil Kopfstatus # 1" },
    { "SAACKE-KAP011"                   , "Positions-Nr. fehlt" },
    { "SAACKE-KAP012"                   , "Positions-Nr. bereits gespeichert" },
    { "SAACKE-KAP013"                   , "Positions-Nr. bereits gespeichert, jedoch storniert" },
    { "SAACKE-KAP014"                   , "Positions-Nr. nicht gespeichert" },
    { "SAACKE-KAP016"                   , "Positions-Nr. bereits storniert" },
    { "SAACKE-KAP034"                   , "Auftragsmenge fehlt" },
    { "SAACKE-KAP036"                   , "Lieferhinweisschlssel (LH) nicht gespeichert" },
    { "SAACKE-KAP038"                   , "Sachbearbeiter fehlt" },
    { "SAACKE-KAP040"                   , "HINWEIS : BS2000 ERWARTET ZUM FELD \"ZUSATZTEXT J/N\" jedoch" },
    { "SAACKE-KAP042"                   , "Liefertermin (ab Werk) falsch !" },
    { "SAACKE-KAP044"                   , "Prioritt nicht gespeichert !" },
    { "SAACKE-KAP090"                   , "" },
    { "SAACKE-KAP094"                   , "" },
    { "SAACKE-KAP098"                   , "" },
    { "SAACKE-KAP113"                   , "Position bereits gespeichert, jedoch gestoppt" },
    { "SAACKE-KAP116"                   , "Position gestoppt" },
    { "SAACKE-KAP117"                   , "Position nicht storniert bzw. gestoppt" },
    { "SAACKE-KAP144"                   , "Hinweis: BS2000 erwartet zum Feld OK ein 'E'" },
    { "SAB-3001"                        , "Ihr Diktatzeichen ist dem System nicht bekannt" },
    { "SAB-3002"                        , "Sie sind nicht fr diese Fachgruppe zugelassen" },
    { "SAB-3003"                        , "Das Kennwort ist falsch" },
    { "SAB-3103"                        , "Ihre Fachgruppe ($1) ist nicht  Eigentmer ($2) des Satzes" },
    { "SAB-3104"                        , "Sie sind nicht fr diese Fachgruppe ($1) autorisiert" },
    { "SAB-3121"                        , "Anlagen-Nr. mu exakt 6-stellig angegeben werden" },
    { "SAB-3122"                        , "Angebots-Nr. mu exakt 8-stellig angegeben werden" },
    { "SAB-3123"                        , "Auftrags-Nr. besteht aus Basis-Nr. (6-stellig) und Zhl-Nr. (3-stellig)" },
    { "SAB-3124"                        , "Auftragszhlnummer ist nicht leer oder 000 beim Anlegen im PPS" },
    { "SAB-3141"                        , "Baustein-Nr. fehlt" },
    { "SAB-3142"                        , "Positions-Nr. fehlt" },
    { "SAB-3143"                        , "Brenner-Nr. fehlt" },
    { "SAB-3144"                        , "Positions-Typ fehlt" },
    { "SAB-3145"                        , "Terminpropagierung ist fr diese Position(en) ($1) nicht mehr zulssig" },
    { "SAB-3146"                        , "PPS-Zugriff ist fr diesen PC nicht eingerichtet. Bitte an den Systemadministrator wenden." },
    { "SAB-3147"                        , "Diese Position ($1) hat keinen PPS-Datensatz im Musterauftrag" },
    { "SAB-3148"                        , "Konflikt zwischen Vertriebsposition und Muster-PPS-Position (Feld: $1)" },
    { "SAB-3149"                        , "Unzulssiges Zeichen ('$1') im PPS-Textfeld" },
    { "SAB-3150"                        , "Terminpropagierung wird fr diese Position(en) ($1) bersprungen (Status 5 oder 9)" },
    { "SAB-3201"                        , "Bitte ein Kriterium fr die Auswahl \"$1\" angeben" },
    { "SAB-3211"                        , "Bearbeiter \"$1\" nicht bekannt" },
    { "SAB-3300"                        , "Fehler bei Ausfhrung von externem Programm '$1': $2. Bitte wenden Sie sich an den Administrator." },
    { "SAN-3000"                        , "Interner Fehler: $1" },
    { "SAN-3001"                        , "Ihr Diktatzeichen ist dem System nicht bekannt. Bitte wenden Sie sich and den Administrator." },
    { "SAN-3002"                        , "Bitte Wert fr Feld '$1' eingeben" },
    { "SAN-3003"                        , "'$1' ist keine gltige Angebotsnummer" },
    { "SAN-3004"                        , "Bitte Wert ungleich Null fr Feld '$1' eingeben" },
    { "SAN-3005"                        , "Bitte Wert fr Feld '$1' inm Bereich von '$2' und '$3' eingeben" },
    { "SAN-3006"                        , "Fr Ihre PC-Nummer ($1) ist kein Vorgangszhler eingetragen" },
    { "SAN-3011"                        , "Nicht untersttzter Datenbankmodus: $1" },
    { "SAN-3103"                        , "Ihre Fachgruppe ($1) ist nicht  Eigentmer ($2) des Satzes" },
    { "SAN-3104"                        , "Sie sind nicht fr diese Fachgruppe ($1) autorisiert" },
    { "SAN-3105"                        , "Die PC-Nummer ($2) stimmt nicht mit der des Angebotes ($1) berein." },
    { "SAN-3111"                        , "Die maximale Angebotszhlnummer ('999') ist schon erreicht" },
    { "SAN-3112"                        , "Die maximale Angebotsbasisnummer ('99999') ist schon erreicht" },
    { "SAN-3131"                        , "Angebotsbasisnummer-Nr. mu exakt 12-stellig angegeben werden" },
    { "SAN-3133"                        , "Angebots-Nr. besteht aus Basis-Nr. (12-stellig) und Zhl-Nr. (3-stellig)" },
    { "SAN-3135"                        , "Bei Fortfhrung eines Angebotes mu die Zhlnummer mit angegeben werden" },
    { "SAN-3136"                        , "Bei manueller Nummernvergabe eines Angebotes mu die Zhlnummer mit angegeben werden" },
    { "SAN-3140"                        , "Menge darf nicht leer sein" },
    { "SAN-3141"                        , "Baustein-Nr. fehlt" },
    { "SAN-3142"                        , "Positions-Nr. fehlt" },
    { "SAN-3143"                        , "Brenner-Nr. fehlt" },
    { "SAN-3144"                        , "Positions-Typ fehlt" },
    { "SAN-3151"                        , "Bei Status 'W' muss auch das Wettbewerber-Feld ausgefllt werden" },
    { "SAN-3152"                        , "Bei Status 'S', 'H' oder 'X' muss auch das Eingangsdatum ausgefllt werden" },
    { "SAN-3153"                        , "Bei Realisierungschance 'hei' mssen auch der Bestell- und Lieferzeitraum im Dialog 'Adressen und Statistik' ausgefllt werden." },
    { "SAN-3161"                        , "Zu einem vollstndigen Angebot muss das Kernerzeugnis ausgefllt sein" },
    { "SAN-3162"                        , "Zu einem vollstndigen Angebot muss der Wrmeerzeuger ausgefllt sein" },
    { "SAN-3163"                        , "Zu einem vollstndigen Angebot muss der Status ungleich '0' sein" },
    { "SAN-3164"                        , "Zu einem vollstndigen Angebot muss der Anfrager ausgefllt sein" },
    { "SAN-3165"                        , "Zu einem vollstndigen Angebot muss die Bindungsfrist ausgefllt sein" },
    { "SAN-3201"                        , "Bitte ein Kriterium fr die Auswahl \"$1\" angeben" },
    { "SAX-1001"                        , "Es fehlt der Anfang des ausgewhlten Bereiches" },
    { "SAX-1002"                        , "Es fehlt das Ende des ausgewhlten Bereiches" },
    { "SAX-1003"                        , "Die Nummer des Musterangebotes/-auftrages fehlt" },
    { "SAX-1004"                        , "Der Zielprefix fehlt" },
    { "SAX-1005"                        , "Keine Positionen gefunden im Bereich von '$1' und '$2'" },
    { "SAX-1006"                        , "Keine Positione Prfix '$1' gefunden" },
    { "SAX-1007"                        , "$1 mit Nummer '$2' nicht gefunden" },
    { "SAX-1008"                        , "Zielprfix '$1' nict anwendbar, da zu kopierende Positionen mit krzeren Nummern existieren" },
    { "SOCKET-1001"                     , "Authoritative Answer: Host not found" },
    { "SOCKET-10012"                    , "ENOMEM  Not enough core (?)" },
    { "SOCKET-1002"                     , "Non-Authoritative: Host not found, or SERVERFAIL" },
    { "SOCKET-1003"                     , "Non recoverable errors, FORMERR, REFUSED, NOTIMP" },
    { "SOCKET-1004"                     , "Valid name, no data record of requested type" },
    { "SOCKET-13"                       , "EACCES  Permission denied" },
    { "SOCKET-14"                       , "EFAULT  Bad address" },
    { "SOCKET-22"                       , "EINVAL  Invalid argument" },
    { "SOCKET-24"                       , "EMFILE  As in standard C" },
    { "SOCKET-32"                       , "EPIPE  Broken pipe  (Verbindung abgebrochen oder Partner nicht erreichbar)" },
    { "SOCKET-35"                       , "EWOULDBLOCK  Operation would block" },
    { "SOCKET-36"                       , "EINPROGRESS  A socket function is called while a blocking function is in progress." },
    { "SOCKET-37"                       , "EALREADY" },
    { "SOCKET-38"                       , "ENOTSOCK  Socket operation on non-socket" },
    { "SOCKET-39"                       , "EDESTADDRREQ  Destination address required" },
    { "SOCKET-4"                        , "EINTR  As in standard C" },
    { "SOCKET-40"                       , "EMSGSIZE  Message too long" },
    { "SOCKET-41"                       , "EPROTOTYPE  Protocol wrong type for socket" },
    { "SOCKET-42"                       , "ENOPROTOOPT  Bad protocol option" },
    { "SOCKET-43"                       , "EPROTONOSUPPORT  Protocol not supported" },
    { "SOCKET-44"                       , "ESOCKTNOSUPPORT" },
    { "SOCKET-45"                       , "EOPNOTSUPP Operation not supported on socket" },
    { "SOCKET-46"                       , "EPFNOSUPPORT" },
    { "SOCKET-47"                       , "EAFNOSUPPORT  Address family not supported by protocol family  (TCP/IP nicht richtig konfiguriert?)" },
    { "SOCKET-48"                       , "EADDRINUSE  Address already in use (Port-Nummer bereits in Gebrauch)" },
    { "SOCKET-49"                       , "EADDRNOTAVAIL  Can't assign requested address" },
    { "SOCKET-50"                       , "ENETDOWN  The Windows Sockets implementation detects an underlying failure." },
    { "SOCKET-51"                       , "ENETUNREACH  Network is unreachable  (ist die Route richtig?)" },
    { "SOCKET-52"                       , "ENETRESET  Network dropped connection or reset" },
    { "SOCKET-53"                       , "ECONNABORTED  Verbindung abgebrochen" },
    { "SOCKET-54"                       , "ECONNRESET  Die Verbindung ist vom Partner oder vom Netzwerk abgebrochen worden" },
    { "SOCKET-55"                       , "ENOBUFS  No buffer space available" },
    { "SOCKET-56"                       , "EISCONN  Socket already connected" },
    { "SOCKET-57"                       , "ENOTCONN  Socket is not connected" },
    { "SOCKET-58"                       , "ESHUTDOWN  Can't send after socket shutdown" },
    { "SOCKET-59"                       , "ETOOMANYREFS" },
    { "SOCKET-60"                       , "ETIMEDOUT  Connection timed out (Keine Verbindung nach Zeitablauf, Host-Name bzw, IP-Nummer richtig?)" },
    { "SOCKET-61"                       , "ECONNREFUSED  Connection refused (TCP-Port nicht erreichbar - Luft der Server?)" },
    { "SOCKET-62"                       , "ELOOP" },
    { "SOCKET-63"                       , "ENAMETOOLONG" },
    { "SOCKET-64"                       , "EHOSTDOWN  Der Rechner ist nicht aktiv" },
    { "SOCKET-65"                       , "EHOSTUNREACH  Das Netzwerk ist nicht erreichbar  (Ist die Route richtig?)" },
    { "SOCKET-9"                        , "EBADF  Bad file number" },
    { "SOCKET-91"                       , "WSASYSNOTREADY  WSAStartup(): Das Netzwerk-Subsystem ist nicht bereit" },
    { "SOCKET-92"                       , "WSAVERNOTSUPPORTED  WSAStartup(): The Windows Sockets DLL cannot support this app." },
    { "SOCKET-93"                       , "WSANOTINITIALISED  WSAStartup() has not yet been performed." },
  //{ "SOS-1000"                        , "Fr die Funktion $1 liegt kein Lizenzschlssel vor (oder der Lizenzschlssel ist abgelaufen). Wenden Sie sich an Ihren Software-Betreuer oder an die Software- und Organisations-Service GmbH, Fax (030) 861 33 35, e-Mail info@sos-berlin.com." },
    { "SOS-1000"                        , "No licence key was found or licence key has expired. Please contact your systems administrator or Software- und Organisations-Service GmbH, Fax +49 (30) 861 33 35, Mail info@sos-berlin.com" },
    { "SOS-1001"                        , "Ungltiger Wert $1 fr Sos_dialog::Sos_form_type" },
    { "SOS-1002"                        , "Operation durch Benutzer abgebrochen" },
    { "SOS-1003"                        , "Der Lizenzschlssel $1 ist ungltig" },
    { "SOS-1004"                        , "Leider sind nicht mehr als $1 Lizenzschlssel mglich" },
    { "SOS-1005"                        , "Der Lizenzschlssel $2 ist am $1 (Jahr Monat Tag) abgelaufen" },
    { "SOS-1006"                        , "Fr die Funktion $1 ist liegt kein Lizenzschlssel vor (oder der Lizenzschlssel ist abgelaufen). Wenden Sie sich an Ihren Software-Betreuer oder an die Software- und Organisations-Service GmbH, Fax (030) 861 33 35, e-Mail info@sos-berlin.com." },
    { "SOS-1007"                        , "Lizenzdatei $1 ist nicht zugreifbar oder defekt" },
    { "SOS-1008"                        , "Dieser Computer namens $1 ist nicht in der Lizenzdatei $2 eingetragen" },
    { "SOS-1009"                        , "In der Registrierung eingetragene sos.ini [$1] existiert nicht oder ist nicht lesbar" },
    { "SOS-1100"                        , "Bitte geben Sie das Datum $1 in der Form tt.mm.[jj]jj an" },
    { "SOS-1101"                        , "$1 ist kein gltiges Datum" },
    { "SOS-1102"                        , "Ungltiges Datum $1: Wert mu in der Zukunft liegen" },
    { "SOS-1103"                        , "Ungltiges Datum $1: Wert mu in der Vergangenheit liegen" },
    { "SOS-1104"                        , "Not a valid date: $1" },
    { "SOS-1105"                        , "Ungltige Ziffer: 0...9, \".\" und \",\" erlaubt" },
    { "SOS-1106"                        , "Feld im Datensatz enthlt nicht \"J\" oder \"N\"" },
    { "SOS-1107"                        , "Zahl $2 ist zu gro oder hat zu viele Nachkommastellen fr $1" },
    { "SOS-1108"                        , "Ungltiger Wert im Feld fr eine EBCDIC-gezonte Zahl" },
    { "SOS-1109"                        , "Wert $1 ist fr das Feld der Gre $2 zu gro" },
    { "SOS-1110"                        , "Dieses Feld hat nur $1 Zeichen" },
    { "SOS-1111"                        , "0-Byte in einer Zeichenkette ist nicht verarbeitbar" },
    { "SOS-1112"                        , "Wert im EBCDIC-gepackten Feld ist auerhalb des gewnschten Bereichs" },
    { "SOS-1113"                        , "Zeichenkette bzw. Datensatz der Lnge $1 ist lnger als $2 (Area)" },
    { "SOS-1114"                        , "Datensatz der Lnge $1 ist krzer als die Feldbeschreibung mit $2 angibt" },
    { "SOS-1115"                        , "Zeichen mu in Apostophe gesetzt sein" },
    { "SOS-1116"                        , "Zeichenkette mu in Anfhrungszeichen gesetzt sein" },
    { "SOS-1117"                        , "String fester Lnge (Sos_limited_text) wird zu lang" },
    { "SOS-1118"                        , "0-Byte in 0-terminierter Zeichenkette fehlt" },
    { "SOS-1119"                        , "Dynamic_area::allocate(): ein Handle ist bereits ausgegeben" },
    { "SOS-1120"                        , "Daten der Lnge $1 zu gro fr Puffer der Gre $2" },
    { "SOS-1121"                        , "Sockets sind noch nicht initialisiert" },
    { "SOS-1122"                        , "Der eigene Hostname und die eigene IP-Adresse sind nicht ermittelbar" },
    { "SOS-1123"                        , "Ungltige Portnummer fr TCP" },
    { "SOS-1124"                        , "Ungltige Satzlnge (Fehler in TCP/IP?)" },
    { "SOS-1125"                        , "Objekt ist kein Filter" },
    { "SOS-1126"                        , "Zeiger auf ein bereits zerstrtes Objekt verwendet" },
    { "SOS-1127"                        , "Filter $1 ist nicht in Gegenrichtung benutzbar" },
    { "SOS-1128"                        , "$1 ist kein Filter" },
    { "SOS-1129"                        , "Fehler beim Anlegen eines Objekts (siehe Log-Datei)" },
    { "SOS-1130"                        , "Objekt $1 ist kein $2  (SOS_CAST)" },
    { "SOS-1131"                        , "Botschaft (request) $2 ohne Ziel von $1" },
    { "SOS-1132"                        , "Botschaft (reply) ohne Ziel von $1" },
    { "SOS-1133"                        , "Botschaft ohne Absender an $1" },
    { "SOS-1134"                        , "Datensatz hat falsche Lnge (falsche Blockung) fr $1" },
    { "SOS-1135"                        , "Ungltige Parameter fr $1: $2" },
    { "SOS-1136"                        , "Sos_object::obj_busy() gerufen, aber return fehlt (interner Fehler vermutlich in $1)" },
    { "SOS-1137"                        , "Botschaft $2 wird vom Objekt $1 nicht untersttzt" },
    { "SOS-1138"                        , "Falsche Lnge bei DDE mit Format sos_binary" },
    { "SOS-1139"                        , "$1 liegt nicht zwischen $2 und $3" },
    { "SOS-1140"                        , "Ungltige Zahl \"$1\"" },
    { "SOS-1141"                        , "include= in Profile rekursiv verwendet" },
    { "SOS-1142"                        , "Eintrag [fs] server= in der Datei sos.ini fehlt" },
    { "SOS-1143"                        , "Interner Fehler: Fileserver bei \"$1\" mit falscher Nachricht angesteuert" },
    { "SOS-1144"                        , "Interner Fehler: Ungltiger Opcode \"$1\" fr Fileserver (inkompatible Version?)" },
    { "SOS-1145"                        , "Client hat eine veraltete Schnittstelle zum Fileserver" },
    { "SOS-1146"                        , "Index $1 auerhalb der Array-Grenzen $2 und $3" },
    { "SOS-1147"                        , "Dateityp \"$1\" unbekannt" },
    { "SOS-1148"                        , "$1 ist beschftigt (busy)" },
    { "SOS-1149"                        , "String ist zu lang fr c_str( String0_area )" },
    { "SOS-1150"                        , "String0_area[ $1 ] bei size=$2" },
    { "SOS-1151"                        , "$1 sendet an ein bereits zerstrtes Objekt $2" },
    { "SOS-1152"                        , "Sos_binary_istream::read_end(): ber das Ende hinaus gelesen" },
    { "SOS-1153"                        , "Sos_binary_istream::read_end(): nicht alle Daten gelesen" },
    { "SOS-1154"                        , "Keine indizierte Datei. Der Dateityp hat keine Methode, einen Satz ber seinen Schlssel zu lesen (get_key)" },
    { "SOS-1155"                        , "Satzsperren nicht mglich (Abs_file::get_record_lock ist nicht implementiert)" },
    { "SOS-1156"                        , "Keine indizierte Datei. Der Dateityp hat keine Methode, zu positionieren (set_key)" },
    { "SOS-1157"                        , "Der Dateityp hat keine Methode, einen Satz einzufgen (insert)" },
    { "SOS-1158"                        , "Der Dateityp hat keine Methode, einen Satz unter einem separatem Schlssel einzufgen (insert_key)" },
    { "SOS-1159"                        , "Der Dateityp hat keine Methode, einen Satz unter einem separatem Schlssel zu speichern (store_key)" },
    { "SOS-1160"                        , "Der Dateityp hat keine Methode, den aktuellen Satz zu lschen" },
    { "SOS-1161"                        , "Der Dateityp hat keine Methode, eine Datei zu entfernen" },
    { "SOS-1162"                        , "Der Dateityp hat keine Methode, den Namen einer Datei zu ndern" },
    { "SOS-1163"                        , "Alias '$1' in sos.ini ist leer oder nicht definiert" },
    { "SOS-1164"                        , "Zugriff auf nicht geffnete Datei" },
    { "SOS-1165"                        , "Fehler in der Kommunikation mit dem Fileserver" },
    { "SOS-1166"                        , "'{' fehlt im (verschachtelten) Datensatz" },
    { "SOS-1167"                        , "'}' fehlt im (verschachtelten) Datensatz" },
    { "SOS-1168"                        , "Feldseparator '$1' fehlt im Datensatz" },
    { "SOS-1169"                        , "Fehler beim Lesen eines Datensatzes (zu kurz?)" },
    { "SOS-1170"                        , "Fehler beim Schreiben eines Datensatzes (zu lang?)" },
    { "SOS-1171"                        , "Dateityp $1 bentigt Satzbeschreibung" },
    { "SOS-1172"                        , "Verbindung zum Fileserver wegen eines vorangegangenen bertragungsfehlers nicht mehr gltig" },
    { "SOS-1173"                        , "Ungltige EBCDIC-gepackte Zahl: $1" },
    { "SOS-1174"                        , "Gepackte Zahl $1 ist zu gro fr $2 Stellen" },
    { "SOS-1175"                        , "Not_exist_error beim Anruf des Fileservers. Mglicherweise fehlt 'tcp:'" },
    { "SOS-1176"                        , "Zahl $1 pat nicht in gepacktes Feld mit $2 Ziffern" },
    { "SOS-1177"                        , "Mehr Nachkommastellen als vom Typ $1 verlangt" },
    { "SOS-1178"                        , "$1 kennt keinen Klientennamen und hat keinen Eigentmer" },
    { "SOS-1179"                        , "Ein Feld $1 gibt es nicht im Datensatz $2" },
    { "SOS-1180"                        , "$1 ist kein Tag des Jahres $2" },
    { "SOS-1181"                        , "String ist nicht abgeschlossen" },
    { "SOS-1182"                        , "Dateiende erwartet" },
    { "SOS-1183"                        , "Feldname $1 ist nicht eindeutig" },
    { "SOS-1184"                        , "Syntaxfehler: \"$1\" erwartet" },
    { "SOS-1185"                        , "Zuviele Parameter" },
    { "SOS-1186"                        , "Feld vom Typ $1 mu gefllt werden, kann nicht nichtig (null) sein" },
    { "SOS-1187"                        , "Field_descr::add_null_flag_to(): zum Feld $1 kann kein Null-Flag angegeben werden, weil der Typ selbst den Nullwert erlaubt" },
    { "SOS-1188"                        , "Typbeschreibung fehlt" },
    { "SOS-1189"                        , "convert: Der Aufrufer hat bereits eine Satzbeschreibung fr sich angegeben" },
    { "SOS-1190"                        , "Satzbeschreibung $1 nicht vertrglich mit $2" },
    { "SOS-1191"                        , "convert: Satzbeschreibung fr den Aufrufer fehlt. Option -type= vor convert fehlt" },
    { "SOS-1192"                        , "Ein Feld mit dem Offset $1 gibt es nicht im Datensatz" },
    { "SOS-1193"                        , "Satzbeschreibung fehlt" },
    { "SOS-1194"                        , "Typbeschreibung fr Feld $1 fehlt (noch nicht konstruiert?)" },
    { "SOS-1195"                        , "Wert ist nicht nichtig (NULL)" },
    { "SOS-1196"                        , "Nicht erkennbare Zeichen am Feldende: $1" },
    { "SOS-1196"                        , "Eintrag $1 im Abschnitt [$2] in der Datei sos.ini o.a. ist zu lang; max. sind $3 Zeichen mglich" },
    { "SOS-1197"                        , "Eintrag $1 im Abschnitt [$2] in der Datei $3 fehlt" },
    { "SOS-1198"                        , "SV-Ressource $1 vom Typ $2 fr $3 fehlt" },
    { "SOS-1199"                        , "Nicht untersttzte SV-Ressource $1 vom Typ $2 fr $3" },
    { "SOS-1200"                        , "Feld mu ausgefllt werden" },
    { "SOS-1201"                        , "Schalter -in im Dateinamen, aber Programm will schreiben" },
    { "SOS-1202"                        , "Schalter -out im Dateinamen, aber Programm will lesen" },
    { "SOS-1203"                        , "Die Liste der Feldnamen enthlt $3 statt $1 Eintrge fr $2" },
    { "SOS-1204"                        , "Satzbeschreibung fehlt (tabbed/record)" },
    { "SOS-1205"                        , "\"$1\" ist kein Standard-Datumsformat oder Standard-Datumszeitformat (s. sosdate.h)" },
    { "SOS-1206"                        , "record/tabbed: Falscher Aufbau der Feldnamenliste einer tabulierten Datei" },
    { "SOS-1207"                        , "$1. Satz der tabulierten Datei hat mit $2 Felder mehr als deklariert" },
    { "SOS-1208"                        , "Typ $1 ist bereits deklariert" },
    { "SOS-1209"                        , "Typ $1 ist nicht bekannt" },
    { "SOS-1210"                        , "Typ $1 ist kein Record" },
    { "SOS-1211"                        , "Aufrufer hat bereits eine Satzbeschreibung $1 vorgelegt" },
    { "SOS-1212"                        , "Aufrufer hat bereits eine Key-Beschreibung $1 vorgelegt" },
    { "SOS-1213"                        , "Verbindung zum Fileserver ist abgebrochen" },
    { "SOS-1214"                        , "Feldbeschreibung fr Schlssel fehlt" },
    { "SOS-1215"                        , "Satz ist mit $1 Bytes krzer als $2, so da er nicht mehr den Schlssel enthlt" },
    { "SOS-1216"                        , "Operation $1 auf Typ $2 nicht implementiert" },
    { "SOS-1217"                        , "Unbekannte Typ-Interpretation $2 fr Feld $1" },
    { "SOS-1218"                        , "Wert $2 ungltig fr Typ $1" },
    { "SOS-1219"                        , "Die Datei kann nur sequentiell bearbeitet werden. inout nicht mglich" },
    { "SOS-1220"                        , "Ein nichtiger Wert (NULL) kann nicht als Satz-Schlssel verwendet werden" },
    { "SOS-1221"                        , "Wert ist fr $1 zu lang: $2" },
    { "SOS-1222"                        , "Wert der Lnge $3 im Feld $2 ist fr $1 zu lang" },
    { "SOS-1223"                        , "Datumsfeld darf keine Uhrzeit enthalten (nur 00:00)" },
    { "SOS-1224"                        , "Dateityp 'sql' bentigt nicht leeren Tabellennamen (Schalter: -table)" },
    { "SOS-1225"                        , "Usage: $1" },
    { "SOS-1226"                        , "Die Fileserver-Verbindung wird gerade fr eine andere Aktion genutzt" },
    { "SOS-1227"                        , "Binrer berlauf bei incr(Area) oder decr(Area)" },
    { "SOS-1228"                        , "Schlssellnge $1 des Aufrufers stimmt nicht mit Schlssellnge $2 der Datei berein" },
    { "SOS-1229"                        , "Satzschlssel kann beim Update nicht gendert werden" },
    { "SOS-1230"                        , "Der $2. Satz hat zuviele tabulierte Felder fr die Satzbeschreibung $1" },
    { "SOS-1231"                        , "Feld $1 enthlt ein Tabulatorzeichen, was in einer tabulierten Datei nicht erlaubt ist" },
    { "SOS-1232"                        , "Zwei Satzbeschreibungen: Fgen Sie den Dateityp convert ein" },
    { "SOS-1233"                        , "update oder delete ist nur unmittelbar nach einer Leseoperation erlaubt" },
    { "SOS-1234"                        , "Genderter Satz hat die Lnge $1, mu aber wie der ursprngliche Satz die Lnge $2 haben" },
    { "SOS-1235"                        , "SQL-Anweisung $1 hat mehr als einen Satz betroffen" },
    { "SOS-1236"                        , "Datei muss entweder nur zum Lesen oder nur zum Schreiben geffnet werden" },
    { "SOS-1237"                        , "Negative Zahl $1 fr vorzeichenloses Feld nicht mglich" },
    { "SOS-1238"                        , "Option $1 kann nur in Verbindung mit einer Datensatzbeschreibung angegeben werden" },
    { "SOS-1239"                        , "Nicht erkannter Text \"$1\"" },
    { "SOS-1240"                        , "Ungltiger Boolscher Wert \"$1\"" },
    { "SOS-1241"                        , "Wert \"$2\" ist fr Feldtyp $1 zu gro" },
    { "SOS-1242"                        , "Tabulatorzeichen ist in einer SQL-Anweisung nicht erlaubt" },
    { "SOS-1243"                        , "Tabulatorzeichen ist im Feld nicht erlaubt (Feld: $1)" },
    { "SOS-1244"                        , "Server-Problem: Client nicht ermittelbar (obj_client() versagt). Mglicherweise ein nicht fileserver-kompatibler Dateityp" },
    { "SOS-1245"                        , "Ungltige Dateinummer $1" },
    { "SOS-1246"                        , "Feld $1 ist im zu kurzen Datensatz der Lnge $2 nicht mehr enthalten" },
    { "SOS-1247"                        , "Feld $1 passt nicht mehr in den Datensatzpuffer der Gre $2" },
    { "SOS-1248"                        , "Cobol-Copy-Strecke $1 enthlt keine Datenbeschreibung" },
    { "SOS-1249"                        , "Diese Demo-Version des Fileservers hat die max. Anzahl von $1 Client-Verbindungen erreicht" },
    { "SOS-1250"                        , "TCP-Verbindung kann nicht aufgebaut werden" },
    { "SOS-1251"                        , "Gesuchter Satz nicht vorhanden, SELECT liefert leere Ergebnismenge" },
    { "SOS-1252"                        , "Interner Fehler: Any_file::prepare() ist nicht durchgefhrt worden" },
    { "SOS-1253"                        , "Interner Fehler: Any_file::execute() oder open() auf geffnete Datei. close() fehlt" },
    { "SOS-1254"                        , "Interner Fehler: Any_file::open(filename) nach Any_file::prepare(filename)" },
    { "SOS-1255"                        , "Interner Fehler: Any_file: Schlsselfeldbeschreibung ohne Typ (=NULL)" },
    { "SOS-1256"                        , "Diese Datei kann nur einmal gelesen werden: Com_file::rewind nicht mglich auf Datei \"$1\" ohne Satzschlssel" },
    { "SOS-1259"                        , "Der genderte oder neue Satz entspricht nicht der View-Bedingung $1" },
    { "SOS-1260"                        , "get_key und set_key sind nur bei SELECT ohne ORDER BY-Klausel mglich" },
    { "SOS-1261"                        , "Datensatz muss wegen maschinenabhngiger Felder im Speicher ausgerichtet sein" },
    { "SOS-1262"                        , "sossql: Dateioperation ohne Ergebnismenge. SQL-Anweisung ist kein Select." },
    { "SOS-1263"                        , "Tabelle $1 ist nicht im Katalog $2" },
    { "SOS-1265"                        , "vflfile: Schlsselposition ist nicht 0" },
    { "SOS-1266"                        , "vflfile: Datensatz enthlt mehr Felder als deklariert" },
    { "SOS-1267"                        , "vflfile: Expandierter Datensatz wird zu lang" },
    { "SOS-1268"                        , "vflfile: Die ersten Felder bilden nicht den Schlssel" },
    { "SOS-1269"                        , "vflfile: Der Wert des Feldes $1 hat die falsche Lnge $2" },
    { "SOS-1270"                        , "Number (type $1) expected, not an empty string" },
    { "SOS-1271"                        , "Dateityp file, Option -key-end=$1 nur ein Zeichen oder \"tab\" mglich" },
    { "SOS-1300"                        , "Unknown option \"$1\"" },
    { "SOS-1301"                        , "Parameter fr Option \"$1\" fehlt" },
    { "SOS-1302"                        , "Syntaxfehler in der Parameterzeile: '$1' fehlt." },
    { "SOS-1303"                        , "Parameter '$1' ist kein Schalter." },
    { "SOS-1304"                        , "Syntaxfehler in Kommandozeile: kein Parameter vorhanden." },
    { "SOS-1305"                        , "Mehr als $1 Parameter" },
    { "SOS-1306"                        , "Der tabulierte Record enthlt nicht genau $1 Eintrge fr $2" },
    { "SOS-1307"                        , "Der ODBC-Treiber untersttzt nicht eine bentigte Funktionalitt ($1)" },
    { "SOS-1308"                        , "Ungltige Option $1 (Syntaxfehler)" },
    { "SOS-1309"                        , "Der Dateityp '$1' kann nur am Ende einer Dateinamenskette stehen" },
    { "SOS-1310"                        , "Letter.wll bzw. Letter16.wll ist nicht als Dokumentvorlage in Word aktiv" },
    { "SOS-1311"                        , "Funktion $1 ist nicht bekannt oder hat nicht $2 Parameter" },
    { "SOS-1312"                        , "Funktion $1 ist schon eingetragen" },
    { "SOS-1313"                        , "Fehler bei OLE-Methode $2: $1" },
    { "SOS-1314"                        , "Die OLE-Funktionen sind nicht implementiert" },
    { "SOS-1315"                        , "Parameter $1 im Alias wird im aufgelsten Dateinamen nicht verwendet" },
    { "SOS-1316"                        , "key/seq: Auf die Datei wird nicht mit aufsteigend geordnetem Schlsselwerten zugegriffen und rewind ist nicht mglich" },
    { "SOS-1317"                        , "record/tabbed: Option -rtrim muss gesetzt werden, wenn fr ein Feld eine maximale Lnge angegeben ist." },
    { "SOS-1318"                        , "record/tabbed: Ungltiger Typ fr Feld $1" },
    { "SOS-1319"                        , "Fr den Dateityp key/seq muss die -key-length= und -key-position= angegeben werden" },
    { "SOS-1320"                        , "Wert $2 im tabulierten Feld $1 ist lnger als deklariert" },
    { "SOS-1321"                        , "Variablenreferenz $'...': Schlieendes Anfhrungszeichen oder Apostroph fehlt" },
    { "SOS-1322"                        , "Ein Feld einer Tabulierten Datei wird in einer unzulssigen Weise verwendet (z.B. als Schlsselfeld). Geben Sie die max. Feldbreite hinter dem Feldnamen an (z.B. \"feldname:8\") oder verwenden Sie -field-size=" },
    { "SOS-1323"                        , "Feld $1 hat ein Null-Flag, was fr einen Schlssel nicht sein darf" },
    { "SOS-1324"                        , "move_offset: Feld $1 hat ein Null-Flag, das auerhalb des Satzes $2 liegt" },
    { "SOS-1325"                        , "Feld $1 hat ein separates Null-Flag, kann darum nicht als Schlssel verwendet werden" },
    { "SOS-1326"                        , "Feld $1 hat einen Typ, der nicht als Schlssel verwendet werden kann" },
    { "SOS-1327"                        , "Option -$1=$2: Nur ein Zeichen ist mglich." },
    { "SOS-1328"                        , "Option -$1=$2: Nur eine ganze Zahl kann angegeben werden." },
    { "SOS-1329"                        , "Option -$1=$2: Nur eine ganze Zahl kann angegeben werden. K fr 1024 und M fr 1048576 kann angefgt werden." },
    { "SOS-1330"                        , "Null dividiert durch Null" },
    { "SOS-1331"                        , "Datenbank-Transaktion dauerte zu lang und wurde deswegen abgebrochen." },
    { "SOS-1332"                        , "Datei kann nur gelesen werden (verwende Schalter -in)" },
    { "SOS-1333"                        , "odbc -field-as-file, aber $1 Felder selektiert" },
    { "SOS-1334"                        , "odbc -field-as-file erfordert Option -fixed-length=N" },
    { "SOS-1335"                        , "Wert ist nichtig (NULL)" },
    { "SOS-1336"                        , "ODBC-Treiber untersttzt -field-as-file nicht: SQL_NEED_LONG_DATA_LEN=Y" },
    { "SOS-1337"                        , "Der Dateityp hat keine Methode, einen Satz direkt zu ndern (update_direct)" },
    { "SOS-1338"                        , "View: Schlsselfeld $1 berlappt ein anderes Schlsselfeld" },
    { "SOS-1339"                        , "View: Der Primrschlssel der Tabelle $1 ist nicht vollstndig selektiert" },
    { "SOS-1340"                        , "View: Tabelle $1 hat keinen Primrschlssel" },
    { "SOS-1341"                        , "View: Schlsselfeld $1 ist nach einem Nicht-Schlsselfeld selektiert. Schlsselfelder mssen fr eine View am Anfang stehen." },
    { "SOS-1342"                        , "Zwischen dem neuen Feld $1 und dem Satzende (Lnge: $2) liegen nicht definierte Felder" },
    { "SOS-1343"                        , "Datensatz $2 wird mit dem Feld $1 zu gro" },
    { "SOS-1344"                        , "Der Fileserver erlaubt nur Schlssel bis zu Lnge von $2 Bytes, angegeben sind aber $1 Bytes." },
    { "SOS-1345"                        , "as_char: Genau ein Zeichen verlangt, aber die Zeichenkette ist leer" },
    { "SOS-1346"                        , "ODBC-Datenquelle '$1' ist schreibgeschtzt." },
    { "SOS-1347"                        , "Array wird grer als 64KB (16bit-Software)" },
    { "SOS-1348"                        , "Ungltiger Paramater flags=$1 fr read_field_as_text()" },
    { "SOS-1349"                        , "Index $1 auerhalb der Grenzen des Arrays $2" },
    { "SOS-1350"                        , "Der Dateityp hat keine Methode, an den Dateianfang zurck zu setzen (rewind) und Schlssellnge ist 0" },
    { "SOS-1351"                        , "set, get_key oder del_key mit Schlssellnge = 0" },
    { "SOS-1352"                        , "Ungltiger Zugriff bei streng sequentiell geffneter Datei (seq)" },
    { "SOS-1353"                        , "Feld $1 ist nicht ODBC-vertrglich, fCType=$2" },
    { "SOS-1354"                        , "Feld $1 ist grer als 64KB" },
    { "SOS-1355"                        , "ODBC-Treiber liefert nicht den SQL-Typ von Feld $1" },
    { "SOS-1356"                        , "Feld vom Typ $1 ist nicht richtig ausgerichtet" },
    { "SOS-1357"                        , "Soll die Datei zum Lesen, Schreiben oder beides geffnet werden?" },
    { "SOS-1358"                        , "Datei ist nicht zum Schreiben geffnet" },
    { "SOS-1359"                        , "hostAPI: Kein Datensatz gelesen" },
    { "SOS-1360"                        , "Dateityp hostole: Der Name der OLE-Klasse fehlt" },
    { "SOS-1361"                        , "Name der Konfigurationsdatei (sos.ini) ist zu lang" },
    { "SOS-1362"                        , "Datei ist bereits geffnet" },
    { "SOS-1363"                        , "Ungltige Byteanzahl fr ein Boolean-Feld" },
    { "SOS-1364"                        , "Feldgruppe $1 hat keinen eigenen Typ. Verwenden Sie die einzelnen Felder (oder in Basic die Anweisung 'Set')" },
    { "SOS-1365"                        , "Ein Bestandteil des Dateinamens ist zu lang fr 8.3-Dateinamen" },
    { "SOS-1366"                        , "Der 8.3-Dateiname enthlt ein nicht zulssiges Zeichen" },
    { "SOS-1367"                        , "Typ $1 des Objekts stimmt nicht mit Typ $2 der Datenstze der Datei berein" },
    { "SOS-1368"                        , "Record $1 enthlt keine Felder und kann nicht mit Daten gefllt werden" },
    { "SOS-1369"                        , "Satzschlssel auf Position $1 ($2 Bytes) ist auerhalb der Satzbeschreibung ($3 Bytes)" },
    { "SOS-1370"                        , "Die View kann keinen Satzschlssel liefern, weil die Variable der LOOP-Klausel nicht selektiert ist" },
    { "SOS-1371"                        , "Der Dateityp hat keine Methode, einen bestimmten Satz zu lschen" },
    { "SOS-1372"                        , "Der Dateityp hat keine Methode, einen Satz zu schreiben" },
    { "SOS-1373"                        , "Der Dateityp hat keine Methode, einen Satz zu lesen" },
    { "SOS-1374"                        , "Der Dateityp hat keine Methode, die die aktuelle Position (den Schlssel) in der Datei liefert" },
    { "SOS-1375"                        , "Das Array hat $1 Elemente und damit mehr als die Feldbeschreibung $2 Felder hat." },
    { "SOS-1376"                        , "Die ODBC-Funktion $1 ist vom Systemverwalter gesperrt worden" },
    { "SOS-1377"                        , "Die View kann keinen Satzschlssel liefern, weil offset=$1, aber keypos+keylen=$2" },
    { "SOS-1378"                        , "Die View kann keinen Satzschlssel liefern, weil die Variable der LOOP-Klausel nicht direkt nach den Schlsselfeldern der Tabellen selektiert ist." },
    { "SOS-1379"                        , "EOF. Kein Satz vor dem gewnschten Schlssel mehr vorhanden" },
    { "SOS-1380"                        , "Datei hat keinen Satzschlssel" },
    { "SOS-1381"                        , "Die View kann keinen Satzschlssel liefern, weil folgender Ausdruck kein Feld der Tabelle $2 ist: $1" },
    { "SOS-1382"                        , "Die View kann keinen Satzschlssel liefern, weil folgendes Feld nicht im Primrschlssel der Tabelle $2 liegt: $1" },
    { "SOS-1383"                        , "Die View kann keinen Satzschlssel liefern, weil das Feld $2 nicht auf den erwarteten Offset $2 liegt" },
    { "SOS-1384"                        , "Die View kann keinen Satzschlssel liefern, weil das Feld $1 ber den Schlssel hinausragt und nicht das letzte ist" },
    { "SOS-1385"                        , "sossql -db=$1 und -catalog=$2 knnen nicht gleichzeitig verwendet werden" },
    { "SOS-1386"                        , "$1 ist nicht als Uhrzeit erkennbar" },
    { "SOS-1387"                        , "Sekundenbruchteil in der Uhrzeit wird nicht untersttzt" },
    { "SOS-1388"                        , "Datei kann nur beschrieben werden" },
    { "SOS-1389"                        , "Fr das Feld $1 kann die Layout-Beschreibung nicht gelesen werden" },
    { "SOS-1390"                        , "Falsche Syntax Parameter -registry" },
    { "SOS-1391"                        , "Die Zeichenfolge '$1' ist kein gltiger Registry Key" },
    { "SOS-1392"                        , "Das Zeichen '$1' an Position $2 ist kein gltiges Hex-Zeichen." },
    { "SOS-1393"                        , "Unzulssige Zeichen am Ende der Datumseingabe: '$1'" },
    { "SOS-1394"                        , "Unzulssiges Zeichen bei numerischer Eingabe: '$1'" },
    { "SOS-1395"                        , "Der in die Datei geschriebene Satz enthlt ein Newline, was wegen -nonl nicht erlaubt ist. Datei $1" },
    { "SOS-1396"                        , "Der ODBC-Treiber liefert keine Ergebnismenge, vermutlich weil die Select-Anweisung fehlerhaft ist (vielleicht ist der Tabellenname unbekannt?)" },
    { "SOS-1397"                        , "Where-Klausel fr Blob-Zugriff fehlt" },
    { "SOS-1398"                        , "Dateityp clipboard wird doppelt benutzt. Die Zwischenablage kann nur einfach geffnet werden" },
    { "SOS-1399"                        , "Dateityp xml: -encoding= ist falsch, mglich sind windows-1252 und iso-8859-1" },
    { "SOS-1400"                        , "Option -type=(...): Feldnamensliste muss in Klammern gesetzt sein" },
    { "SOS-1401"                        , "Fehler an der $2. Zeichenposition in der Option -type=$1" },
    { "SOS-1402"                        , "Das XML-Dokument ist abgeschnitten (Dateiende erreicht)" },
    { "SOS-1402"                        , "Ungltige Zeichen im XML-Dokument" },
    { "SOS-1403"                        , "$1 im XML-Dokument erwartet" },
    { "SOS-1404"                        , "Attribut index=\"nummer\" fr ein Array-Feld erwartet" },
    { "SOS-1405"                        , "Tag $1 bezeichnet kein Feld im Datensatz" },
    { "SOS-1406"                        , "Tag $1 bezeichnet ein Gruppenfeld, fr das aber kein direkter Wert angegeben werden kann" },
    { "SOS-1407"                        , "Hinter dem Ende-Tag des XML-Dokuments steht nicht erkannter Text" },
    { "SOS-1408"                        , "Dateityp xml kann nur eine verschachtelte Datenstruktur verarbeiten, wenn sie aus einer Cobol-Satzbeschreibung stammt (flat_scope)." },
    { "SOS-1409"                        , "XML-Tag $1 bezeichnet ein Array-Element (OCCURS), aber hat kein Attribut \"index\"." },
    { "SOS-1410"                        , "XML-Tag $1 hat ein Attribut \"index\", aber bezeichnet kein Array-Element (OCCURS)" },
    { "SOS-1411"                        , "Processor::add_obj: NULL-Pointer als Objekt bergeben" },
    { "SOS-1412"                        , "Dateityp profile: Parameter -group= fehlt" },
    { "SOS-1413"                        , "Syntaxfehler in %-Funktion" },
    { "SOS-1414"                        , "Dateityp cache: Vorangegangener Fehler in der temporren Datei" },
    { "SOS-1415"                        , "Umgebungsvariable TMP oder TEMP ist nicht gesetzt" },
    { "SOS-1416"                        , "Dateityp cache: Operation ohne Dateiname" },
    { "SOS-1417"                        , "Dateityp prog: Eintrag dir= im Abschnitt [prog] der Konfigurationsdatei sos.ini fehlt" },
    { "SOS-1418"                        , "Dateityp prog: Mehr als $1 Argumente fr das Programm" },
    { "SOS-1419"                        , "Dateityp prog: Programm schreibt nach stdout, bevor es stdin ausgelesen hat" },
    { "SOS-1420"                        , "Option -$1=$2: Nur eine Gleitpunktzahl kann angegeben werden." },
    { "SOS-1421"                        , "Eintrag $2 im Abschnitt [$1] der Konfigurationsdatei enthlt keine Festpunktzahl" },
    { "SOS-1422"                        , "XML-Element <$1> fehlt" },
    { "SOS-1423"                        , "XML-Element <$1> ist doppelt" },
    { "SOS-1424"                        , "COM-Fehler: " },
    { "SOS-1425"                        , "Fehler im Skript: $1" },
    { "SOS-1426"                        , "Keine hexadezimale Zahl: $1" },
    { "SOS-1427"                        , "Skript wird abgebrochen" },
    { "SOS-1428"                        , "Die Scripting Engine ist noch nicht eingerichtet" },
    { "SOS-1429"                        , "Das Skript ist gestartet. Parameter knnen nicht mehr aufgenommen werden." },
    { "SOS-1430"                        , "Die Variable ist kein Array, der Index kann nicht angewendet werden" },
    { "SOS-1431"                        , "Dateityp tab: Feldseparator fehlt in der $1. Zeile" },
    { "SOS-1432"                        , "Werte vom Typ $1 knnen nicht addiert werden" },
    { "SOS-1433"                        , "set_parameter($1): Parameter (SQL) werden nicht lckenlos gesetzt" },
    { "SOS-1434"                        , "set_parameter($1): Parameter (SQL) ndert seinen Typ" },
    { "SOS-1435"                        , "Keine ganze Zahl: $1" },
    { "SOS-1436"                        , "Fr Nachkommastellen wird nur ein Dezimalpunkt (kein Komma) akzeptiert: $1" },
    { "SOS-1437"                        , "Die Genauigkeit (precision=$1) des dezimalen Tgyps kann nicht geringer sein als die Anzahl Nachkommastellen (scale=$2)" },
    { "SOS-1438"                        , "Kein akzeptierter VARIANT-Typ: $1" },
    { "SOS-1439"                        , "Dateityp create_table -dbms=$1 ist nicht bekannt. Verwenden Sie z.B. oracle oder jet." },
    { "SOS-1440"                        , "Dateityp create_table braucht eine Satzbeschreibung, wie sie der Dateityp columns liefert" },
    { "SOS-1441"                        , "Dateityp create_table: Unbekannter Spaltentyp $1" },
    { "SOS-1442"                        , "eMail-Adresse ist nicht korrekt aufgebaut" },
    { "SOS-1443"                        , "read_profile_string(): Name des Abschnitts ist leer, entry=$1" },
    { "SOS-1444"                        , "eMail-Empfngerliste ist nicht korrekt aufgebaut" },
    { "SOS-1445"                        , "Fr Dateidatenbank $1 ist kein passender ODBC-Treiber installiert" },
    { "SOS-1446"                        , "UPDATE hat $1 Stze gendert, verlangt sind aber -rows=$2" },
    { "SOS-1447"                        , "Die installierten Lizenzschlssel erlauben nicht, den gewnschten Lizenzschlssel zu generieren" },
    { "SOS-1448"                        , "move_offset: $1 liegt auerhalb des Satzes $2" },
    { "SOS-1449"                        , "-key= erwartet die Schlsselfelder zusammenhngend von links nach rechts. Feld $1" },
    { "SOS-1450"                        , "Skriptspache $1 ist nicht bekannt" },
    { "SOS-1451"                        , "Fr den eMail-Versand kann nur 'jmail' (Windows) oder 'java' verwendet werden, nicht aber $1" },
  //{ "SOS-1452"                        , "JDBC-Datentyp $1 ist nicht verarbeitbar" },
    { "SOS-1453"                        , "Treiber $1 akzeptiert nicht den URL $2" },
    { "SOS-1454"                        , "Ungltiger Variablenname: \"$1\"" },
    { "SOS-1455"                        , "com_invoke: Objekt fehlt beim Aufruf von $1" },
    { "SOS-1456"                        , "Variablenname, der der Scripting Engine hinzugefgt werden soll, ist leer" },
    { "SOS-1457"                        , "%limit ist fr das DBMS $1 nicht implementiert" },
    { "SOS-1458"                        , "%limit ist nur fr Anweisung select mglich" },
    { "SOS-1459"                        , "%limit(n) ist nicht richtig angegeben" },
    { "SOS-1460"                        , "Hostware (hostole.dll/libhostware.so) hat die Version $2, gefordert ist aber $1" },
    { "SOS-1461"                        , "XML-Element <$1> erwartet" },
    { "SOS-1462"                        , "Variable $1 mit unbekanntem Objekttyp kann nicht nach XML konvertiert werden" },
    { "SOS-1463"                        , "#include: Vorlage oder Textbaustein $1 ist in der Datenbank nicht bekannt" },
    { "SOS-1464"                        , "File is no database" },
    { "SOS-2000"                        , "Fehler 'exception': $1" },

    // Fehlercodes ab SOS-3000 im Modul zschimmer.cxx (ersetzt fr SOS Z-3000)
    
    { "SOS-COBOL-1"                     , "Cobol-Datenbeschreibung: Ungltiges Zeichen" },
    { "SOS-COBOL-10"                    , "Cobol-Datenbeschreibung: REDEFINE $1 erwartet" },
    { "SOS-COBOL-11"                    , "Cobol-Datenbeschreibung: Stufennummer $1 statt $2 fr REDEFINE erwartet" },
    { "SOS-COBOL-12"                    , "Cobol-Datenbeschreibung: Nicht untersttzter Typ: $1" },
    { "SOS-COBOL-13"                    , "Cobol-Datenbeschreibung: IS oder PICTURE-Klause erwartet" },
    { "SOS-COBOL-14"                    , "Cobol-Datenbeschreibung: String ist nicht abgeschlossen" },
    { "SOS-COBOL-15"                    , "Cobol-Datenbeschreibung: $1 erwartet" },
    { "SOS-COBOL-16"                    , "Cobol-Datenbeschreibung: Felddeklaration, Kommentar oder Dateiende erwartet" },
    { "SOS-COBOL-17"                    , "Cobol-Datenbeschreibung: -vlen: Nicht erlaubter Feldtyp $1 im BS2000-Satzlngenfeld der Cobol-Satzbeschreibung" },
    { "SOS-COBOL-18"                    , "Cobol-Datenbeschreibung: Schlsselwort $1 wird nicht untersttzt" },
    { "SOS-COBOL-19"                    , "Cobol-Datenbeschreibung: Cobol-Feld $1 ist keine Gruppe, darf keinen Typ haben, wenn eine hhrere Stufennummer folgt" },
    { "SOS-COBOL-2"                     , "Cobol-Datenbeschreibung: ')' in PICTURE-Klause fehlt" },
    { "SOS-COBOL-3"                     , "Cobol-Datenbeschreibung: Ungltiges Zeichen '$1' in der PICTURE-Klause" },
    { "SOS-DDE-001"                     , "Ein zweiter DDE-Server kann nicht gestartet werden." },
    { "SOS-DDE-002"                     , "DDE-Funktion nicht implementiert (DDE_FNOTPROCESSED)" },
    { "SOS-DDE-003"                     , "Conversation-Handle von DDEML unbekannt" },
    { "SOS-DDE-003"                     , "Topic-Handle von DDEML unbekannt" },
    { "SOS-DDE-004"                     , "Nur das Text-Format wird untersttzt" },
    { "SOS-DDE-005"                     , "Der DDE-Server bearbeitet schon eine DDE-Anfrage, bitte warten Sie" },
    { "SOS-EBO-101"                     , "DB-Name ist mit $1 Zeichen zu lang. Maximum ist $2" },
    { "SOS-EBO-102"                     , "Der Katalog $1 soll geffnet werden, dabei ist schon der Katalog $2 offen" },
    { "SOS-EBO-103"                     , "Syntax fr -ip=position/lnge nicht korrekt: -pi=$1" },
    { "SOS-EBO-104"                     , "Syntax fr -ip=name,position/lnge,... nicht korrekt: -pi=$1" },
    { "SOS-EBO-105"                     , "Bei -si= muss bergebene Schlsselposition ($1) 0 sein" },
    { "SOS-EBO-106"                     , "Beim ffnen ber Sekundrindex (-si=) darf die Feldauswahl (-fa=$1) nicht angegeben sein." },
    { "SOS-EBO-107"                     , "bergebene Schlsselposition $1 entspricht nicht der Angabe in -pi=$2/... (die Zhlweisen sind verschieden, s. Doku). Oder bei -fa=mainitem muss Schlsselposition 0 sein." },
    { "SOS-EBO-108"                     , "bergebene Schlssellnge $1 entspricht nicht der Angabe in -pi=.../$2" },
    { "SOS-EBO-109"                     , "Bei -fa=mainitem muss -pi= angegeben sein" },
    { "SOS-EBO-110"                     , "bergebene Schlsselposition $1 muss 0 sein bei -fa=mainitem" },
    { "SOS-EBO-111"                     , "Bei -si= muss bergebene Schlssellnge ($1) die Summe der Lngen von Sekundrindex und Primrindex $2 sein" },
    { "SOS-FILE-1100"                   , "FS: current_key() liefert andere Schlssellnge" },
    { "SOS-FRAME-1"                     , "Ungltiges Zeichen" },
    { "SOS-FRAME-2"                     , "$1 erwartet" },
    { "SOS-FRAME-3"                     , "Unbekannte Feldoption $1 im .df" },
    { "SOS-FRAME-4"                     , "Nicht untersttzter Feldtyp" },
    { "SOS-FRAME-5"                     , "on/off/ja/nein erwartet" },
    { "SOS-HOSTAPI-1"                   , "sos_init() fehlgeschlagen" },
    { "SOS-HOSTAPI-2"                   , "sos_exit() fehlgeschlagen" },
    { "SOS-HOSTAPI-3"                   , "sos_exit(): Dateien sind noch offen" },
    { "SOS-INGRES-1"                    , "SQL-SELECT nur bei open mglich" },
    { "SOS-INGRES-2"                    , "Nur SELECT bei open mglich" },
    { "SOS-OBJ-1001"                    , "Unbekannte Botschaft" },
    { "SOS-OBJ-1004"                    , "Keine Botschaft in der Warteschlange und keine wird erwartet" },
    { "SOS-OBJ-1005"                    , "Rekursiver synchroner Aufruf in Sos_dummy_client" },
    { "SOS-OBJ-1006"                    , "Unerwartete Antwort bei einem synchronen Aufruf in Sos_dummy_client" },
    { "SOS-OBJ-1007"                    , "Unerwartete Antwort ohne synchronen Aufruf in Sos_dummy_client" },
    { "SOS-OBJ-1009"                    , "Botschaften-Warteschlange ist voll" },
    { "SOS-OBJ-1010"                    , "Objekt-Semaphore ist negativ" },
    { "SOS-OBJ-1013"                    , "Sos_ptr auf ein nicht mit new angefordertes Objekt" },
    { "SOS-OBJ-1100"                    , "Externe Botschaft $1 hat falsche Lnge" },
    { "SOS-OBJ-1101"                    , "Unbekannte externe Botschaft" },
    { "SOS-OBJ-1102"                    , "Ungltige Objekt-ID" },
    { "SOS-OBJ-1103"                    , "Doppelte Objekt-ID" },
    { "SOS-OBJ-1104"                    , "Externe Botschaft Sos_client::open hat falsche Lnge" },
    { "SOS-PARSER-101"                  , "Nicht erkanntes Zeichen, Bezeichner oder Symbol" },
    { "SOS-PARSER-102"                  , "Symbol $1 nicht erkannt" },
    { "SOS-PARSER-103"                  , "Symbol ist zu lang" },
    { "SOS-PARSER-104"                  , "Zeichenkette ist nicht abschlossen" },
    { "SOS-PARSER-105"                  , "Kein Hexadezimalzeichen nach \\x in einer Zeichenkette" },
    { "SOS-PARSER-201"                  , "SGML-Tag endet nicht mit '>'" },
    { "SOS-PARSER-202"                  , "&-Entity ist nicht mit ';' abgeschlossen" },
    { "SOS-PARSER-203"                  , "&-Entity ist zu lang" },
    { "SOS-PARSER-204"                  , "&-Entity nicht definiert" },
  //{ "SOS-PHP-101"                     , "Dynobj-Nummer ist ungltig" },
    { "SOS-PHP-101"                     , "Objektnummer $2 im Register $1 ist ungltig" },
    { "SOS-PHP-103"                     , "Parameter $1 ist nicht vom Typ $2" },
    { "SOS-PHP-104"                     , "hostphp.inc passt nicht zur hostphp.dll?" },
    { "SOS-SQL-1"                       , "Syntax-Fehler: Kommentar ist nicht mit */ abgeschlossen" },
    { "SOS-SQL-10"                      , "Syntax-Fehler: Typbezeichnung erwartet" },
    { "SOS-SQL-1000"                    , "$1" },
    { "SOS-SQL-1001"                    , "Zusicherung $2 ist nicht erfllt fr $1" },
    { "SOS-SQL-1002"                    , "Der Tabelle $3 fehlt ein Satz mit der Bedingung $2" },
    { "SOS-SQL-1003"                    , "Bedingung $2 ist nicht erfllt fr $1" },
    { "SOS-SQL-11"                      , "Syntax-Fehler: $1 erwartet statt \"$2\"" },
    { "SOS-SQL-12"                      , "Syntax-Fehler: Feldname, Konstante oder geklammerter Ausdruck erwartet" },
    { "SOS-SQL-13"                      , "Aggregatsfunktion kann nur im select verwendet werden" },
    { "SOS-SQL-14"                      , "Syntax-Fehler: Unbekannte SQL-Anweisung" },
    { "SOS-SQL-15"                      , "Syntax-Fehler: Outer Join: Fr die uere Tabelle muss ein Feldname angegeben werden statt $1" },
    { "SOS-SQL-16"                      , "Syntax-Fehler: \"|\" kann nicht mit FROM-Klausel kombiniert werden" },
    { "SOS-SQL-2"                       , "Syntax-Fehler: Ungltige Zeichenfolge: $1" },
    { "SOS-SQL-3"                       , "Syntax-Fehler: String ist nicht abgeschlossen" },
    { "SOS-SQL-50"                      , "Tabelle $1 ist nicht in der FROM-Klausel aufgefhrt" },
    { "SOS-SQL-51"                      , "Feld $1 in Tabelle $2 oder in Tabelle $3?" },
    { "SOS-SQL-52"                      , "Feld $1 ist nicht bekannt" },
    { "SOS-SQL-53"                      , "Funktion $1 ist nicht bekannt" },
    { "SOS-SQL-54"                      , "Funktion $1 bentigt $2 Parameter, angegeben sind aber $3" },
    { "SOS-SQL-55"                      , "Datei $1 hat keine Satzbeschreibung" },
    { "SOS-SQL-56"                      , "Mit bind_parameter() $1 Parameter gesetzt, Anweisung hat aber $2 Parametermarken" },
    { "SOS-SQL-57"                      , "bind_parameter() fehlt, obwohl die Anweisung Parametermarken hat" },
    { "SOS-SQL-58"                      , "SELECT *, aber FROM-Klausel fehlt" },
    { "SOS-SQL-59"                      , "Zweiter Parameter von SUBSTR mu mindesten 1 sein ist aber $2" },
    { "SOS-SQL-60"                      , "Bei mehreren Tabellen muss fr ROWID die Tabelle benannt werden: tabelle.ROWID" },
    { "SOS-SQL-61"                      , "Die Tabelle $1 hat keine ROWID" },
    { "SOS-SQL-62"                      , "ORDER BY-Index $1, obwohl nur $2 Felder selektiert sind." },
    { "SOS-SQL-63"                      , "ORDER BY-Index bei SELECT * nicht mglich" },
    { "SOS-SQL-64"                      , "sossql ORDER BY: Sortierer ist belegt" },
    { "SOS-SQL-65"                      , "Mehr als %1 Ausdrcke sind bei ORDER BY nicht mglich" },
    { "SOS-SQL-66"                      , "Spalte $2 ($1) ist kein Satzschlssel einer Tabelle" },
    { "SOS-SQL-67"                      , "get_key oder set_key: Schlssel deckt nicht Feld $1 der Tabelle $2 ab" },
    { "SOS-SQL-68"                      , "get_key, set_key oder del_key: Schlssel ist nicht im Bereich der WHERE-Klausel (evtl. der View)" },
    { "SOS-SQL-69"                      , "Nur ein Outer Join ist mglich: Tabelle $1" },
    { "SOS-SQL-70"                      , "sossql -join-error-log=DATEI fehlt fr das Protokoll zum Join-Operator :=" },
    { "SOS-SQL-71"                      , "Outer Join fr $1 ist zu tief verschachtelt" },
    { "SOS-SQL-72"                      , "Join mit zwei ueren Tabellen?" },
    { "SOS-SQL-73"                      , "Das Feld $1 ist nicht in der ersten Tabelle. Nur die Felder der ersten Tabelle der Select-Ergebnismenge knnen gendert werden." },
    { "SOS-SQL-74"                      , "Das Feld $1 ist konstant \"$2\", kann nicht gendert werden" },
    { "SOS-SQL-75"                      , "Das Feld $1 ist ein Ausdruck, kann nicht gendert werden" },
    { "SOS-SQL-76"                      , "Keine nderbare Tabelle" },
  //{ "SOS-SQL-77"                      , "Die Tabellen $1 und $2 sind gegenseitig abhngig" },
    { "SOS-SQL-78"                      , "Zwei Joins auf die selbe Tabelle $2 nicht mglich. $1" },
    { "SOS-SQL-79"                      , "Lnge $2 des aktuellen Schlssels stimmt nicht mit der vorgegebenen Schlssellnge der Tabelle $1 berein" },
    { "SOS-SQL-80"                      , "Funktion $1 fr diese Parameterliste nicht bekannt" },
    { "SOS-SQL-81"                      , "Objektname $1 doppelt definiert" },
    { "SOS-SQL-82"                      , "Objekt $1 ist nicht deklariert. Deklaration mit: SET <obj> = CreateObject( '<klassenname>' );" },
    { "SOS-SQL-83"                      , "Falsche Anzahl Parameter fr Funktionsaufruf" },
    { "SOS-SQL-84"                      , "Funktion translate: Zweiter und dritter Parameter sind nicht gleich lang" },
    { "SOS-SQL-85"                      , "Verschachteltes Select darf nur eine Spalte liefern" },
    { "SOS-SQL-86"                      , "Reihenfolge der Klausel nicht eingehalten. Richtig ist: FROM, WHERE, ASSERT, LOOP, LET, ORDER BY" },
    { "SOS-SQL-87"                      , "Verschachteltes Select liefert mehr als eine Satz" },
    { "SOS-SQL-89"                      , "Mehr als $1 Ausdrcke sind bei GROUP BY nicht mglich" },
    { "SOS-SQL-90"                      , "Typ des Arguments der Aggregatsfunktion ist $2, erwartet wird aber $1" },
    { "SOS-SQL-91"                      , "Mehr als -max-reads=$1 Stze aus den zugrundeliegenden Tabellen gelesen" },
    { "SOS-SQL-92"                      , "Ergebnismenge bei -max-records=$1 geschlossen" },
    { "SOS-SQL-93"                      , "Das Feld $1 wird auerhalb einer Aggregatsfunktion oder eines GroupBy-Ausdrucks verwendet" },
    { "SOS-SQL-94"                      , "(interner Fehler) Die Schlssellngen der Schlsselintervalle sind nicht gleich" },
    { "SOS-SQL-95"                      , "Alle TOP $1 Stze gelesen" },
    
    { "SOSFLAM-1"                       , "SATZ VERKUERZT" },
    { "SOSFLAM-10"                      , "DATEI IST KEINE FLAMFILE" },
    { "SOSFLAM-2"                       , "FLAMFILE IST LEER" },
    { "SOSFLAM-20"                      , "UNZULAESSIGER OPENMODE" },
    { "SOSFLAM-21"                      , "UNZULAESSIGE GROESSE DES MATRIXPUFFERS" },
    { "SOSFLAM-22"                      , "UNZULAESSIGES KOMPRESSIONSVERFAHREN" },
    { "SOSFLAM-23"                      , "UNZULAESSIGER CODE IN FLAMFILE" },
    { "SOSFLAM-24"                      , "UNZULASSIGE MAXIMALE SATZANZAHL" },
    { "SOSFLAM-25"                      , "UNZULAESSIGE SATZLAENGE" },
    { "SOSFLAM-3"                       , "LUECKE IN RELATIVER DATEI" },
    { "SOSFLAM-30"                      , "EINGABEDATEI IST LEER" },
    { "SOSFLAM-31"                      , "EINGABEDATEI IST NICHT VORHANDEN" },
    { "SOSFLAM-32"                      , "UNZULAESSIGER OPEN-MODE FUER DATEI" },
    { "SOSFLAM-33"                      , "UNZULAESSIGES DATEIFORMAT" },
    { "SOSFLAM-34"                      , "UNZULAESSIGES SATZFORMAT" },
    { "SOSFLAM-35"                      , "UNZULASSIGE SATZLAENGE FUER DATEI" },
    { "SOSFLAM-36"                      , "UNZULASSIGE BLOCKGROESSE" },
    { "SOSFLAM-37"                      , "UNZULAESSIGE SCHLUESSELPOSITION" },
    { "SOSFLAM-38"                      , "UNZULAESSIGE SCHLUESSELLAENGE" },
    { "SOSFLAM-39"                      , "UNZULAESSIGER DATEINAME" },
    { "SOSFLAM-4"                       , "SATZ AUFGEFUELLT" },
    { "SOSFLAM-40"                      , "MODUL KANN NICHT GELADEN WERDEN" },
    { "SOSFLAM-41"                      , "MODUL KANN NICHT AUFGERUFEN WERDEN" },
    { "SOSFLAM-42"                      , "MODUL KANN NICHT ENTLADEN WERDEN" },
    { "SOSFLAM-43"                      , "FEHLERABBRUCH DURCH EXIT" },
    { "SOSFLAM-44"                      , "FEHLERABBRUCH DURCH EXIT (RETCO=20)" },
    { "SOSFLAM-45"                      , "FEHLERABBRUCH DURCH EXIT (RETCO=24)" },
    { "SOSFLAM-46"                      , "FEHLERABBRUCH DURCH EXIT (RETCO=28)" },
    { "SOSFLAM-47"                      , "FEHLERABBRUCH DURCH EXIT (RETCO=32)" },
    { "SOSFLAM-48"                      , "FEHLERABBRUCH DURCH EXIT (RETCO=36)" },
    { "SOSFLAM-49"                      , "FEHLERABBRUCH DURCH EXIT (RETCO=40)" },
    { "SOSFLAM-5"                       , "SCHLUESSEL NICHT VORHANDEN" },
    { "SOSFLAM-6"                       , "NEUE DATEI BEGINNT" },
    { "SOSFLAM-9"                       , "CLIMIT UEBERSCHRITTEN" },
    { "SOSFLAM-96"                      , "KEINEN DATEINAMEN GEFUNDEN" },
    { "SOSFLAM-98"                      , "NICHT ALLE DATEIEN BEARBEITET" },
    { "SOSFLAM-999"                     , "REQM-FEHLER BZW UNGUELTIGE FUNKTION" },
    
    { "SOSODBC-10"                      , "Handle wird bereits benutzt (rekursiver Aufruf durch Windows-Ereignis?)" },
    { "SOSODBC-11"                      , "ibScale bei SQLBindParameter() ist nicht 0" },
    { "SOSODBC-12"                      , "Feld $1 ist nicht von einem gltigen SQL-Typ" },
    
    { "WINSOCK-10004"                   , "EINTR  Socket-Aufruf ist unterbrochen worden" },
    { "WINSOCK-10009"                   , "EBADF  Bad file number" },
    { "WINSOCK-10012"                   , "ENOMEM  Not enough core (?)" },
    { "WINSOCK-10013"                   , "EACCES  Permission denied" },
    { "WINSOCK-10014"                   , "EFAULT  Bad address" },
    { "WINSOCK-10022"                   , "EINVAL  Invalid argument" },
    { "WINSOCK-10024"                   , "EMFILE  As in standard C" },
    { "WINSOCK-10032"                   , "EPIPE  Broken pipe  (Verbindung abgebrochen oder Partner nicht erreichbar)" },
    { "WINSOCK-10035"                   , "EWOULDBLOCK  Operation would block" },
    { "WINSOCK-10036"                   , "EINPROGRESS  A socket function is called while a blocking function is in progress." },
    { "WINSOCK-10037"                   , "EALREADY" },
    { "WINSOCK-10038"                   , "ENOTSOCK  Socket operation on non-socket" },
    { "WINSOCK-10039"                   , "EDESTADDRREQ  Destination address required" },
    { "WINSOCK-10040"                   , "EMSGSIZE  Message too long" },
    { "WINSOCK-10041"                   , "EPROTOTYPE  Protocol wrong type for socket" },
    { "WINSOCK-10042"                   , "ENOPROTOOPT  Bad protocol option" },
    { "WINSOCK-10043"                   , "EPROTONOSUPPORT  Protocol not supported" },
    { "WINSOCK-10044"                   , "ESOCKTNOSUPPORT" },
    { "WINSOCK-10045"                   , "EOPNOTSUPP Operation not supported on socket" },
    { "WINSOCK-10046"                   , "EPFNOSUPPORT" },
    { "WINSOCK-10047"                   , "EAFNOSUPPORT  Address family not supported by protocol family" },
    { "WINSOCK-10048"                   , "EADDRINUSE  Address already in use (Port-Nummer bereits in Gebrauch)" },
    { "WINSOCK-10049"                   , "EADDRNOTAVAIL  Can't assign requested address" },
    { "WINSOCK-10050"                   , "ENETDOWN  The Windows Sockets implementation detects an underlying failure." },
    { "WINSOCK-10051"                   , "ENETUNREACH  Network is unreachable" },
    { "WINSOCK-10052"                   , "ENETRESET  Network dropped connection or reset" },
    { "WINSOCK-10053"                   , "ECONNABORTED  Verbindung abgebrochen" },
    { "WINSOCK-10054"                   , "ECONNRESET  Die Verbindung ist vom Partner oder vom Netzwerk abgebrochen worden" },
    { "WINSOCK-10055"                   , "ENOBUFS  No buffer space available" },
    { "WINSOCK-10056"                   , "EISCONN  Socket already connected" },
    { "WINSOCK-10057"                   , "ENOTCONN  Socket is not connected" },
    { "WINSOCK-10058"                   , "ESHUTDOWN  Can't send after socket shutdown" },
    { "WINSOCK-10059"                   , "ETOOMANYREFS" },
    { "WINSOCK-10060"                   , "ETIMEDOUT  Connection timed out (Keine Verbindung nach Zeitablauf)" },
    { "WINSOCK-10061"                   , "ECONNREFUSED  Connection refused (TCP-Port nicht erreichbar)" },
    { "WINSOCK-10062"                   , "ELOOP" },
    { "WINSOCK-10063"                   , "ENAMETOOLONG" },
    { "WINSOCK-10064"                   , "EHOSTDOWN  Der Rechner ist nicht aktiv" },
    { "WINSOCK-10065"                   , "EHOSTUNREACH  Das Netzwerk ist nicht erreichbar - falsche Route?" },
    { "WINSOCK-10091"                   , "WSASYSNOTREADY  WSAStartup(): Das Netzwerk-Subsystem ist nicht bereit" },
    { "WINSOCK-10092"                   , "WSAVERNOTSUPPORTED  WSAStartup(): The Windows Sockets DLL cannot support this app." },
    { "WINSOCK-10093"                   , "WSANOTINITIALISED  WSAStartup() has not yet been performed." },
    { "WINSOCK-11001"                   , "Authoritative Answer: Host not found" },
    { "WINSOCK-11002"                   , "Non-Authoritative: Host not found, or SERVERFAIL" },
    { "WINSOCK-11003"                   , "Non recoverable errors, FORMERR, REFUSED, NOTIMP" },
    { "WINSOCK-11004"                   , "Valid name, no data record of requested type" },
    { "ZLIB-100"                        , "Nicht mit gzip komprimierte Daten" },
    { NULL                              , NULL },
};

} //namespace sos
